function [Data_] = Decompose_ConstVar(...
    Data, Opt_DSB)
% Data = [freq, pwr]
% LSB: [df, df] = |[I 1]     [Z(w)]|   [ '' ]
%                 |[0 1]   * [Z0  ]| = [Data]
% USB: [df, df] = |  [1 0] * [Z0  ]| = [Data]
%                 |  [1 I]   [Z(w)]|   [ '' ]

disp('--------- Decompose_ConstVar ')
%% ########## Separate Const + FreqDepVar
NumDF = size(Data, 1);
	if ~IsEven_Func(NumDF)
     	error('NumDF in Data is ODD');
	end

switch Opt_DSB
    %-------------------------
    case{'DSB'}
        NumDF = NumDF / 2;
    %-------------------------
    %case{'SSB'}
    %-------------------------
    %otherwise
end
Eq_MAT_h	= [1              	zeros(1,NumDF-1); ...
               ones(NumDF-1,1)	eye(NumDF-1,NumDF-1)];
           
switch Opt_DSB
    %-------------------------
    case{'DSB'}
        Eq_MAT_l	= fliplr(flipud( Eq_MAT_h ));
        Eq_MAT      = [Eq_MAT_l         zeros(NumDF); ...
                       zeros(NumDF)     Eq_MAT_h];
    %-------------------------
    case{'SSB'}
        Eq_MAT      = Eq_MAT_h;
    %-------------------------
    %otherwise
end
Data_ = Eq_MAT \ Data;
