function [Data_ConstVar     Data_Const	Data_Var] = Decompose_ConstVar_2(...
    Data, Opt_DSB)
% Data = [freq, pwr]
% LSB: [df, df] = |[I 1]     [Z(w)]|   [ '' ]
%                 |[0 1]   * [Z0  ]| = [Data]
% USB: [df, df] = |  [1 0] * [Z0  ]| = [Data]
%                 |  [1 I]   [Z(w)]|   [ '' ]
disp('--------- Decompose_ConstVar ')

NumDF = size(Data, 1);
%% ######################################## Separate Const + FreqDepVar
switch Opt_DSB
    %-------------------------
    case{'DSB'}
        if ~IsEven_Func(NumDF)
            error('NumDF in DSB-Data is ODD');
        end
        NumDF   = NumDF / 2;
    %-------------------------
    %case{'SSB'}
    %-------------------------
    %otherwise
end
        Eq_MAT_h	= [ 1              	zeros(1,NumDF-1); ...
                        ones(NumDF-1,1)	eye(NumDF-1,NumDF-1) ];% for USB
           
switch Opt_DSB
    %-------------------------
    case{'DSB'}
        Eq_MAT_l	= fliplr(flipud( Eq_MAT_h ));% for LSB
        Eq_MAT      = [Eq_MAT_l         zeros(NumDF); ...
                       zeros(NumDF)     Eq_MAT_h];% for DSB
    %-------------------------
    case{'SSB'}
        Eq_MAT      = Eq_MAT_h;% for USB
    %-------------------------
    %otherwise
end
Data_ConstVar = Eq_MAT \ Data;

switch Opt_DSB
    %-------------------------
    case{'DSB'}
        Data_Const  = Data_ConstVar( NumDF+(0:1), :);% Mid-Col = Const
        Data_Var 	= Data_ConstVar;
            Data_Var( NumDF+(0:1), :) = zeros( size(Data_Const) );% ZeroOut Mid-Col
    %-------------------------
    case{'SSB'}
        Data_Const  = Data_ConstVar( 1, :);% 1st-Col = Const
        Data_Var 	= Data_ConstVar;
            Data_Var( 1, :) = zeros( size(Data_Const) );% ZeroOut 1st-Col
    %-------------------------
    %otherwise
end

%% ######################################## scrap
if(0)
    

end