function [z] = ExprEVALnum_Func( ...
    Expr, SymChar, VecCEL, LEN) 
%----------------------------
% z = COLvec
%----------------------------
%   Expr        = sym               Hv{n}(nV,1)
%   SymChar     = Syms-in-Expr      Hv_SymCHAR{nV,n}
%   VecCEL      = Expr_NumCEL{nSYM}
%               {COLvec [LEN]}    
%   LEN         = Hv_NumfreqptsCEL{nV,n}
if ~exist('LEN','var')
	LEN = 0;
    for nCEL = 1 : size(VecCEL,2)
        LEN_new = size(VecCEL{nCEL}, 1);
        if(LEN_new > LEN)
            LEN = LEN_new;
        end
    end
end

if(Expr ~= 0)
%% ###########################
%t_1 = tic;
FuncHandle   	= eval(['@(' SymChar ') ' char(Expr)]);   % KEEP NAME FuncHandle
%disp(['t_1 = ' num2str( toc(t_1) )])
%whos SymChar Expr FuncHandle

%t_2 = tic;
FuncHandle_str	= 'FuncHandle(';                        % KEEP NAME FuncHandle
%----------------------------------------------
for nPARAM = 1 : length(VecCEL)% #Sym
switch length( VecCEL{nPARAM} )
 	case {1}
        FuncHandle_str = [FuncHandle_str 'VecCEL{' num2str(nPARAM) '},' ];
	case {LEN}
      	FuncHandle_str = [FuncHandle_str 'VecCEL{' num2str(nPARAM) '}(nLEN),' ];% KEEP NAME nLEN
    otherwise
      	disp(['VecCEL(' int2str(nPARAM) ') of Non-Conforming length']);
end
end
%----------------------------------------------
FuncHandle_str = [FuncHandle_str(1:end-1) ')'];% end-1 RIDOF of LAST ','
%disp(['t_2 = ' num2str( toc(t_2) )])

%t_3 = tic;
%----------------------------------------------
for nLEN = 1 : LEN% KEEP NAME nLEN
    z(nLEN,1) = eval(FuncHandle_str);
end
%----------------------------------------------
%disp(['t_3 = ' num2str( toc(t_3) )])

%% ###########################
else
    z = 0;
end