function [  Hv_NumfreqptsCEL ] = ExprSUBnumfreqpts_Func( ...
	Hv_SymCEL_IDX, N, MatCEL, ...
	Opt_Disp)
% Input:
%	Hv_SymCEL_IDX{nV,n} = SymCEL_IDX
%      	SymCEL_IDX      = IDX of these Syms in SymCEL / MatCEL
%                     	{nCEL [nSYM;IDX  nSYM;IDX ...for diff Z#]}
%	MatCEL              = corresp to SymCEL
%                      	{zNumCEL{:} aNumCEL{:}}
%     	InputNumCEL{:} not included => b.c Length 1
% Output:
%	Hv_NumfreqptsCEL{nV,n} = max# NumFreqPts
%                     	for each [nSYM;IDX] in SymCEL_IDX(nCEL)
%                       found in each MatCEL{nCEL}

Hv_NumfreqptsCEL = {};% {nV,n} NumFreqPts
%%
for n = 1 : N
%******************************************************
for nV = 1 : size(Hv_SymCEL_IDX,1)
    SymCEL_IDX  = Hv_SymCEL_IDX{nV,n};% {nCEL [nSYM;IDX  nSYM;IDX]}
if ~isempty(SymCEL_IDX)
    NumFreqPts  = 1;
%----------------------------------------------
for nCEL = 1 : length(MatCEL)% type of Param, (< length(SymCEL_IDX))
    % SymCEL_IDX{nCEL}% DEBUG
%----------------------------------------------
for nZ = 1 : size(SymCEL_IDX{nCEL},2)
 	%nSYM 	= SymCEL_IDX{nCEL}(1,nZ);
   	IDX   	= SymCEL_IDX{nCEL}(2,nZ);
	%###########################
	NumFreqPts_NEW = length( MatCEL{nCEL}(:,IDX) );
  	if(NumFreqPts < NumFreqPts_NEW)
        if(NumFreqPts ~= 1)
            disp('>1 but UnEqual NumFreqPts NumFreqPts_NEW')
        end
     	NumFreqPts = NumFreqPts_NEW;
    end
end
%----------------------------------------------
end
    Hv_NumfreqptsCEL{nV,n} = NumFreqPts;
end
%----------------------------------------------
end
%******************************************************
end
