function [pSSB_Cmplx offset pSSB pDSB] = Extract_xSSB2( ...
    VSA, Opt_Attempt, ...
    figVEC, marker)

disp('______________________________________________ Extract_xSSB2 ')
%%  #################### %(df, output)
OptimMeth	= 'lsqnonlin';
nPwr        = 1;
Opt_Disp    = 0;

[pSSB_Real_0, offset] = Buss_XR_InitGuess(Opt_Attempt, VSA, nPwr, Opt_Disp);

disp('______________________ Buss_XR_Iter ')
[Err_Real_0, ymodel_0, pSSB_0, pDSB_0] = Buss_XR_Iter(...
    OptimMeth, pSSB_Real_0, offset, VSA, nPwr);

disp('______________________ Buss_XR_Iter ')
options	= optimset(OptimMeth);
switch OptimMeth
    %------------------------------------------------
    case{'lsqnonlin'}
        options = optimset(options, 'PrecondBandWidth',0, ...
            'TolFun',0.01, ...
            'Display','final', ...% {'notify' 'iter' 'final'}
            'MaxFunEvals',400*length(pSSB_Real_0),'MaxIter',100);% Default=[100*,400], [400*length(x2_0), 600] 
    [pSSB_Real, resnorm,residual,exitflag,output] = lsqnonlin( @(pSSB_Real) ...
        Buss_XR_Iter(OptimMeth, pSSB_Real, offset, VSA, nPwr), ...
        pSSB_Real_0, [],[],options);
    %------------------------------------------------
    case{'lsqcurvefit'}
        options	= optimset(options, 'PrecondBandWidth',0);% 'TolX',1e-8);
        xdata = VSA.fSSB_Lin;
        ydata = VSA.H3_DSBavg(:,n_pwr);
    [pSSB_Real, resnorm, residual] = lsqcurvefit( @(pSSB_Real, xdata) ...
        Buss_XR_Iter(OptimMeth, pSSB_Real, offset, VSA, nPwr), ...
        pSSB_Real_0, xdata, ydata, [],[],options);
    %------------------------------------------------
end
pSSB_Cmplx = Param_Real2Cmplx( pSSB_Real );

disp('______________________ Buss_XR_Iter ')
[Err_Real, ymodel, pSSB, pDSB] = Buss_XR_Iter(...
    OptimMeth, pSSB_Real, offset, VSA, nPwr);

%% Plot of Fitting-Result
if ~isempty( figVEC )
%------------------------------- RI Plot
n_idx =1;
    %----- pDSB_0
if (figVEC(1) > 0)
    plot_Sio_Func(VSA.fDSB_dB, pDSB_0,...
        'RI','RI-Lin', figVEC(1),'Xlin',['-.m' marker(n_idx)], ...
        [],['Baseband Filter'],['Envelop Freq (dBKhz)'],{},['Init Estim'])
    %----- pDSB
	plot_Sio_Func(VSA.fDSB_dB, pDSB,...
        'RI','RI-Lin', figVEC(1),'Xlin',['-r' marker(n_idx)], ...
        [],[],[],{},['Final Estim'])
end

if (figVEC(2) > 0)
    %----- H3
	plot_Sio_Func(VSA.fDSB_dB, VSA.H3_DSBavg(:,nPwr), ...
        'RI','RI-Lin', figVEC(2),'Xlin',['-b' marker(n_idx)], ...
        [],['NLTF'],['Envelop Freq (dBKhz)'],{},['Measured'])
    %----- ymodel_0
    plot_Sio_Func(VSA.fDSB_dB, ymodel_0, ...
        'RI','RI-Lin', figVEC(2),'Xlin',['-.m' marker(n_idx)], ...
        [],[],[],{},['Init Modeled'])
    %----- ymodel
	plot_Sio_Func(VSA.fDSB_dB, ymodel,...
        'RI','RI-Lin', figVEC(2),'Xlin',['-r' marker(n_idx)], ...
        [],[],[],{},['Final Model'])
end
%------------------------------- MA Plot
if (figVEC(3) > 0)
    %----- pDSB_0
	plot_Sio_Func(VSA.fDSB_dB, Lin2MA_MA(pDSB_0),...
        'MA','RI-Lin', figVEC(3),'Xlin',['-.m' marker(n_idx)], ...
        [],['Baseband Filter'],['Envelop Freq (dBKhz)'],{},['Init Estim'])
    %----- pDSB
	plot_Sio_Func(VSA.fDSB_dB, Lin2MA_MA(pDSB),...
        'MA','RI-Lin', figVEC(3),'Xlin',['-r' marker(n_idx)], ...
        [],[],[],{},['Final Estim'])
end

if (figVEC(4) > 0)
    %----- H3
	plot_Sio_Func(VSA.fDSB_dB, Lin2MA_MA(VSA.H3_DSBavg(:,nPwr)), ...
        'MA','RI-Lin', figVEC(4),'Xlin',['-b' marker(n_idx)], ...
        [],['NLTF'],['Envelop Freq (dBKhz)'],{},['Measured'])
    %----- ymodel_0
	plot_Sio_Func(VSA.fDSB_dB, Lin2MA_MA(ymodel_0),...
        'MA','RI-Lin', figVEC(4),'Xlin',['-.m' marker(n_idx)], ...
        [],[],[],{},['Init Model'])
    %----- ymodel
	plot_Sio_Func(VSA.fDSB_dB, Lin2MA_MA(ymodel),...
        'MA','RI-Lin', figVEC(4),'Xlin',['-r' marker(n_idx)], ...
        [],[],[],{},['Final Model'])
end
%-------------------------------
end

return
%% ####################
function [Err_Real ymodel pSSB pDSB] = Buss_XR_Iter(...
    OptimMeth, pSSB_Real, offset, ...
    VSA, nPwr)

pSSB_Cmplx = Param_Real2Cmplx( pSSB_Real );
pSSB	= pSSB_Cmplx(offset + (1:VSA.NumDF));
pDSB	= Cat_Func( conj(pSSB), pSSB, 'DSB');

    ymodel	= pSSB_Cmplx(1) + pSSB_Cmplx(2) * pDSB;
switch OptimMeth
    %------------------------------------------------
    case{'lsqnonlin'}
        Err_Cmplx	= ymodel - VSA.H3_DSBavg(:,nPwr);
    %------------------------------------------------
    case{'lsqcurvefit'}
        Err_Cmplx	= ymodel;
    %------------------------------------------------
end

    Err_Real = Param_Cmplx2Real( Err_Cmplx );
return
%% ####################
function [pSSB_Real_0, offset] = Buss_XR_InitGuess( ...
    Opt_Attempt, VSA, nPwr, Opt_Disp)

disp('______________________ Buss_XR_InitGuess ');
switch Opt_Attempt
    %----------------------------------------------
    case{ 11,12 }% 1st:ConstVar separation, 2nd:EvenOdd separation 
[H3_DSB_ConstVar]	= Decompose_ConstVar(VSA.H3_DSBavg, 'DSB');
    H3_DSB_Const    = H3_DSB_ConstVar( VSA.NumDF+(0:1), :);
        H3_DSB_Const%DEBUG
        H3_DSB_Const = H3_DSB_EVEN_Const(1,1)
    H3_DSB_Var      = H3_DSB_ConstVar;
    H3_DSB_Var( VSA.NumDF+(0:1), :) = zeros( size(H3_DSB_Const) );
[H3_DSB_VarEVEN     H3_DSB_VarODD] = Decompose_EvenOdd(H3_DSB_Var);
	XRRatEVEN_VEC	=   imag( H3_DSB_VarEVEN(:,nPwr) )	./ real( H3_DSB_VarEVEN(:,nPwr) );
	XRRatODD_VEC	= - real( H3_DSB_VarODD(:,nPwr) )	./ imag( H3_DSB_VarODD(:,nPwr) );
	%----------------------------------------------
    case{ 21,22 }% 1st:EvenOdd separation, 2nd:ConstVar separation
[H3_DSB_EVEN     H3_DSB_ODD] = Decompose_EvenOdd(VSA.H3_DSBavg);
	%H3_DSB_ODD: intrinsic ODD w/Const~0, NO need separate
       if(Opt_Disp)
           [H3_DSB_EVEN(:,1)	H3_DSB_ODD(:,1)]%DEBUG
       end
[H3_DSB_EVEN_ConstVar]	= Decompose_ConstVar(H3_DSB_EVEN, 'DSB');
    H3_DSB_EVEN_Const   = H3_DSB_EVEN_ConstVar( VSA.NumDF+(0:1), :);
        H3_DSB_Const    = H3_DSB_EVEN_Const(1,1);
    H3_DSB_EVEN_Var     = H3_DSB_EVEN_ConstVar;
    H3_DSB_EVEN_Var( VSA.NumDF+(0:1), :) = zeros( size(H3_DSB_EVEN_Const) );
[H3_DSB_ODD_ConstVar]	= Decompose_ConstVar(H3_DSB_ODD,  'DSB');
    H3_DSB_ODD_Const    = H3_DSB_ODD_ConstVar( VSA.NumDF+(0:1), :);
    H3_DSB_ODD_Var      = H3_DSB_ODD_ConstVar;
    H3_DSB_ODD_Var( VSA.NumDF+(0:1), :) = zeros( size(H3_DSB_ODD_Const) );
    %---------DEBUG
	if(Opt_Disp) 
        [H3_DSB_EVEN_ConstVar(:,1)	H3_DSB_ODD_ConstVar(:,1)]%DEBUG
        %H3_DSB_EVEN_Const
        %H3_DSB_ODD_Const% almost 0 except at 1st pwr-level
        %[H3_DSB_EVEN_Var(:,1)       H3_DSB_ODD_Var(:,1)]%DEBUG
    end
    clear H3_DSB_ODD_ConstVar   H3_DSB_ODD_Const	H3_DSB_ODD_Var
XRRatEVEN_VEC	=   imag( H3_DSB_EVEN_Var(:,nPwr) )	./ real( H3_DSB_EVEN_Var(:,nPwr) );
%XRRatODD_VEC	= - real( H3_DSB_ODD_Var(:,nPwr) )	./ imag( H3_DSB_ODD_Var(:,nPwr) );
XRRatODD_VEC	= - real( H3_DSB_ODD(:,nPwr) )      ./ imag( H3_DSB_ODD(:,nPwr) );
	%----------------------------------------------
end
    %if(Opt_Disp)
    %    [XRRatEVEN_VEC      XRRatODD_VEC]%DEBUG
    %end
IDX_start       = floor( VSA.NumDF/4 );
IDX_stop        = VSA.NumDF*2 - IDX_start;
XRRatEVEN_VEC   = XRRatEVEN_VEC([IDX_start:VSA.NumDF-2	VSA.NumDF+3:IDX_stop]);
XRRatODD_VEC    = XRRatODD_VEC( [IDX_start:VSA.NumDF-2	VSA.NumDF+3:IDX_stop]);
    %if(Opt_Disp)
    %    [XRRatEVEN_VEC      XRRatODD_VEC]%DEBUG
    %end
    XRRat_const = mean([median(XRRatEVEN_VEC) median(XRRatODD_VEC)])%-1.2;
    XRRat_const = exp(j*atan(XRRat_const))
    Lin2MA_MA( XRRat_const )%DEBUG
    
pSSB_Cmplx_0 = [H3_DSB_Const;   XRRat_const];
offset    	= length(pSSB_Cmplx_0);
switch Opt_Attempt
	%----------------------------------------------
    case{ 11 }
        pSSB_Cmplx_0	= [pSSB_Cmplx_0;     real( H3_DSB_VarEVEN(VSA.NumDF+1:end,   nPwr) ) ...
                                    + j*imag( H3_DSB_VarODD(VSA.NumDF+1:end,    nPwr) ) ];
    case{ 12 }
        pSSB_Cmplx_0	= [pSSB_Cmplx_0;     imag( H3_DSB_VarEVEN(VSA.NumDF+1:end,   nPwr) ) ...
	                          	    - j*real( H3_DSB_VarODD(VSA.NumDF+1:end,    nPwr) ) ];
	%----------------------------------------------
    case{ 21 }
        pSSB_Cmplx_0	= [pSSB_Cmplx_0;     sign( real(XRRat_const) ) * ...
                                   (    real( H3_DSB_EVEN_Var(VSA.NumDF+1:end,  nPwr) ) ...
                                    + j*imag( H3_DSB_ODD(VSA.NumDF+1:end,       nPwr) )) ];
                                   %+ j*imag( H3_DSB_ODD_Var(VSA.NumDF+1:end,   nPwr) )) ];
    case{ 22 }
        pSSB_Cmplx_0	= [pSSB_Cmplx_0;     sign( imag(XRRat_const) ) * ...
                                   (    imag( H3_DSB_EVEN_Var(VSA.NumDF+1:end,  nPwr) ) ...
	                          	    - j*real( H3_DSB_ODD(VSA.NumDF+1:end,       nPwr) )) ];
	                          	   %- j*real( H3_DSB_ODD_Var(VSA.NumDF+1:end,   nPwr) )) ];
    case{ 23 }% ~22 with -1 factor: B31 * Hbb(w) = -B31 * -Hbb(w)
        pSSB_Cmplx_0	= [pSSB_Cmplx_0;   - sign( imag(XRRat_const) ) * ...
                                   (    imag( H3_DSB_EVEN_Var(VSA.NumDF+1:end,  nPwr) ) ...
	                          	    - j*real( H3_DSB_ODD(VSA.NumDF+1:end,       nPwr) )) ];
	%----------------------------------------------
end
    if(Opt_Disp)
        pSSB_Cmplx_0(1       :offset)%DEBUG
    	pSSB_Cmplx_0(offset+1:end).'%DEBUG
    end

    pSSB_Real_0 = Param_Cmplx2Real( pSSB_Cmplx_0 );
return
%% Test
if(0)

end