function [ Ynp_RI Opt_YNP ] = Freeda_SNP2YNP( File_SNP, File_YNP,...
        NumPort, Opt_SNP, Opt_YNP )
% Touchtone S2P(y2p) -> Freeda y2p


[Freq	Snp_RI     Header] = Read_SnP_Func( File_SNP, NumPort, Opt_SNP);
    [Header{1}{1} ' ' Header{2}{1} ' ' Header{3}{1} ' ' Header{4}{1} ' ' Header{5}{1} ' ' Header{6}{1}]% DEBUG

[ Ynp_RI ] = S2Y_CEL( Snp_RI, str2double(Header{6}{1}), str2double(Header{6}{1}) );
    File_YNP = lower(  File_YNP );
if exist( File_YNP,'file')
    disp([ File_YNP ' exists']);
    return
else
    Opt_YNP.Zo = 50;% must be 50ohm for Freeda to sim, though really is 1ohm
    Opt_YNP.Header	= Header;
    %switch upper( Header{2}{1} )
    %    case{'HZ'}
    %        Opt_YNP.Header{2}{1} = 'Hz';
    %    case{'KHZ'}
    %        Opt_YNP.Header{2}{1} = 'KHz';
    %    case{'MHZ'}
    %        Opt_YNP.Header{2}{1} = 'MHz';
    %    case{'GHZ'}
    %        Opt_YNP.Header{2}{1} = 'GHz';
    %    case{'THZ'}
    %        Opt_YNP.Header{2}{1} = 'THz';
    %end
    ['# ' Opt_YNP.Header{2}{1} ' Y RI R ' num2str(Opt_YNP.Zo)]% DEBUG
    %sprintf(    '\n%s %s %s %s %s %d ','#',Opt.Header{2}{1},'Y','RI','R',Opt.Zo)% DEBUG
    Write_SnP_Freeda( Freq, Ynp_RI, NumPort, File_YNP, Opt_YNP );
end

%% ######################################### Test
if(0)

Opt_YNP.Zo = 1;% already down to 1ohm during S2Y
%R_ref = 50;% still 50ohm during S2Y
Ynp_{1} = Lin2MA_MA( 1 ./   Ynp_RI{1}       *Opt_YNP.Zo );
Ynp_{2} = Lin2dB_dB( 0.5 *  Ynp_RI{2} *50   /Opt_YNP.Zo );
Ynp_{3} = Lin2dB_dB( 0.5 *  Ynp_RI{3} *50   /Opt_YNP.Zo );
Ynp_{4} = Lin2MA_MA( 1 ./   Ynp_RI{4}       *Opt_YNP.Zo );
    plot_SMatrix_Func3( Freq, Ynp_, [1 2 2 1]+0, ...
        {'MA' 'dB' 'dB' 'MA'}, 'yLin', 'xLin', {}, ...
        {}, {}, {}, {{'Z11' 'Y12*25' 'Y21*25' 'Z22'}}, ...
        {'-k.' '-k.' '-r.' '-r.'}, PlotOpt, 1)
%---------------------------------------------------------------------
DUT         = 'SD513301';
Char        = 'FreqResp';
FileNam_SNP = 'SD513301_1Mhz8Ghz_1khz_-20dBm_InputSMAsilver_Atten20dB_15.17VDC.s2p';
File_SNP    = fullfile( PATH.Data, DUT, Char, FileNam_SNP)
NumPort     = 2;
Opt_SNP     = struct('IOformat',{'dB2RI'}, 'IOPortConv',{'ADSPNA2port_2_Gen'});
    %-----------------------
Opt_SNP     = struct('IOformat',{'dB2dB'}, 'IOPortConv',{'ADSPNA2port_2_Gen'});
[Freq	Snp_dB     Header] = Read_SnP_Func( File_SNP, NumPort, Opt_SNP);
    plot_SMatrix_Func3( Freq, Snp_dB, [1 2 2 1]+20, ...
        {'dB'}, 'yLin', 'xLin', {}, ...
        {}, {}, {}, {{'S11'} {'S12'} {'S21'} {'S22'}}, ...
        {'-ko' '-ko' '-b.' '-b.'}, PlotOpt, 1)
%--------------------------------------------------------------------- Agilent.Y2P => Freeda.Y2P
FileNam_SNP = 'ADSsawtek_465Mhz_2Ghz_RI_y2p.s2p';
File_SNP    = fullfile( PATH.FREEDA_Models, FileNam_SNP)
NumPort     = 2;
Opt_SNP     = struct('IOformat',{'RI2RI'}, 'IOPortConv',{'ADSPNA2port_2_Gen'});
[Freq	Ynp_RI     Header] = Read_SnP_Func( File_SNP, NumPort, Opt_SNP);
    File_YNP = fullfile( PATH.FREEDA_Models, ...
                [lower(  FileNam_SNP(1:end-4) ) '_freeda.y2p'])
    Opt_YNP	= struct('Precision',{'%16.15e'});

%---------------------------------------------------------------------
DUT         = 'Cosite';
Char        = 'DEMBEDparts';
FileNam_SNP = 'Line-rx_1-8001Mhz_-20dBmAtt10_1Khz_16001pts10ms.s2p';
File_SNP    = fullfile( PATH.Data, DUT, Char, FileNam_SNP)
NumPort     = 2;
Opt_SNP     = struct('IOformat',{'dB2RI'}, 'IOPortConv',{'ADSPNA2port_2_Gen'});
    %-----------------------
Opt_SNP     = struct('IOformat',{'dB2dB'}, 'IOPortConv',{'ADSPNA2port_2_Gen'});
[Freq	Snp_dB     Header] = Read_SnP_Func( File_SNP, NumPort, Opt_SNP);
    plot_SMatrix_Func3( Freq, Snp_dB, [1 2 2 1]+20, ...
        {'dB'}, 'yLin', 'xLin', {}, ...
        {}, {}, {}, {{'S11'} {'S12'} {'S21'} {'S22'}}, ...
        {'-ko' '-ko' '-b.' '-b.'}, PlotOpt, 1)
%======================================================================
File_YNP = fullfile( PATH.FREEDA_Models, ...
                [lower(  FileNam_SNP(1:end-4) ) '_freeda.y2p'])
Opt_YNP     = struct('Precision',{'%16.15e'});
%-----------------------
Freeda_SNP2YNP( File_SNP, File_YNP, NumPort, Opt_SNP, Opt_YNP );

% ADS S-sim, DataFileTool write dataset Sawtek_465Mhz_WideBand's
% Y-param (Scientific 12decimal) to Touchstone file
% "R 1" in output file
% but works in Freeda when "R 50" , thus no rescaling needed

FileNam_1   = 'ADSsawtek_465Mhz_2Ghz_RI_y2p.s2p';           % mhz Y ri R 1 (R=1ohm)
            % 'sawtek2_465Mhz_2Ghz_RI_y2p_INCORR.s2p'       % MHz Y RI R 50 (scaled by 50)
FileNam_2   = 'adssawtek_465Mhz_2Ghz_ri_y2p_jlo.s2p';       % Mhz Y RI R 50 (R=50ohm) # port:group
    [max_freq] = Freeda_y2p_Touchstone2Freeda( Path_FREEDA_Comp,FileNam_1, FileNam_2)


FileNam_1   = 'ADSpwrsplit_1hz_1thz_RI_y2p.s3p';        	% mhz Y ri R 1 (R=1ohm)
FileNam_4   = 'ADSpwrsplit_1hz_1thz_RI_y2p_12.s2p';       % mhz Y ri R 1 (R=1ohm)
FileNam_5   = 'ADSpwrsplit_1hz_1thz_RI_y2p_13.s2p';       % mhz Y ri R 1 (R=1ohm)
%
FileNam_2   = 'adspwrsplit_1hz_1thz_ri_y2p_12freeda.s2p';	% Mhz Y RI R 50 (R=50ohm) # port:group
FileNam_3   = 'adspwrsplit_1hz_1thz_ri_y2p_13freeda.s2p';	% Mhz Y RI R 50 (R=50ohm) # port:group
    [max_freq] = Freeda_y3p_Touchstone2Freeda( Path_FREEDA_Comp,FileNam_1, FileNam_2,FileNam_3, FileNam_4,FileNam_5)

end