function [Pin HarmIDX Freq VarIDX HBout HBvar_MixVec] = Read_MDF_HB_Func(...
	Var_Indep, Var_Dep, Var_DepStruct, ...
    Opt_HB, Opt_MixVec, Opt_Var)
% HBout {n_Var, n_Harm}

switch Opt_HB
%% ###############################
    case {'1D_Pin'}
Pin     = Var_Indep{3,1};
VarIDX_offset   = 1;
HBvar_HarmIDX   = 2;

%%##############################################################
HBvar	= Var_DepStruct{1};
%#################### HBvar_MixVec
NumTone         = size(Opt_MixVec,2);% 1
HBvar_MixVecIDX = VarIDX_offset + (1:NumTone);% [2] IDX to MixVec in HBvar
HBvar_MixVec = [];% MixVec in HBvar
for n_Var = 1 : length(HBvar_MixVecIDX)
    HBvar_MixVec = [HBvar_MixVec [squeeze(HBvar{3,HBvar_MixVecIDX(n_Var)}(1,:))] ];
end
%#################### HarmIDX (=HBvar_MixVec for 1Tone)
HarmIDX = [];
if isempty(Opt_MixVec)
    HarmIDX = [squeeze(HBvar{3,HBvar_HarmIDX}(1,:))];
else
    HarmIDX = Find_VecIDX_Func(HBvar_MixVec, Opt_MixVec);
end
%#################### VarIDX
VarIDX = [];% IDX to Vars in HBvar
if isempty(Opt_Var)
    VarIDX = [HBvar_MixVecIDX(end)+1 : size(HBvar,2)];
else
    VarIDX = Find_VecIDX_Func(HBvar(1,:), Opt_Var);
end
%#################### harmindex Freq HBout
Freq  = [squeeze(HBvar{3,VarIDX_offset}(1,HarmIDX))];
HBout = {};% Vars in HBvar
for n_Var = 1 : length(Opt_Var)
    HBvar{1,VarIDX(n_Var)}% BEH_Vout Vout_I Vin
    %size(HBvar{3,VarIDX(n_Var)})
for n_Harm = 1 : length(HarmIDX)
    HBout{n_Var, n_Harm} = (squeeze( HBvar{3,VarIDX(n_Var)}(:,HarmIDX(n_Harm)) )).';
end
end
%#################### Opt_MixVec [MixVec NumTone]
HarmIDX%    [MixVec]
Freq%       [MixVec]
%#################### %Opt_Var    [Var]
VarIDX%     [Var]
HBout%      [Var MixVec]

%% ###############################
    case {'2D_df_Pin'}
dfswp   = Var_Indep{3,1};
Pin     = Var_Indep{3,2};
    %HBvar	= Var_DepStruct{2};
    %Pin = squeeze(HBvar{3,1}(1,end,:)).';
VarIDX_offset	= 2;
HBvar_HarmIDX   = 1;

%%##############################################################
HBvar	= Var_DepStruct{1};
%#################### HBvar_MixVec
NumTone         = size(Opt_MixVec,2);% 2
HBvar_MixVecIDX = VarIDX_offset + (1:NumTone);% [3 4] IDX to MixVec in HBvar
HBvar_MixVec = [];% MixVec in HBvar
for n_Var = 1 : length(HBvar_MixVecIDX)
    HBvar_MixVec = [HBvar_MixVec [squeeze(HBvar{3,HBvar_MixVecIDX(n_Var)}(1,1,:))] ];
end
%#################### HarmIDX
HarmIDX = [];
if isempty(Opt_MixVec)
    HarmIDX = [squeeze(HBvar{3,HBvar_HarmIDX}(1,1,:))];
else
    HarmIDX = Find_VecIDX_Func(HBvar_MixVec, Opt_MixVec);
end
%#################### VarIDX
VarIDX = [];% IDX to Vars in HBvar
if isempty(Opt_Var)
    VarIDX = [HBvar_MixVecIDX(end)+1 : size(HBvar,2)];
else
    VarIDX = Find_VecIDX_Func(HBvar(1,:), Opt_Var);
end
%#################### harmindex Freq HBout
Freq  = [squeeze(HBvar{3,VarIDX_offset}(:,1,HarmIDX))];
HBout = {};
for n_Var = 1 : length(VarIDX)% length(Opt_Var)
    HBvar{1,VarIDX(n_Var)}% Vout Vin
    %size(HBvar{3,VarIDX(n_Var)})
for n_Harm = 1 : length(HarmIDX)
  	HBout{n_Var, n_Harm} = squeeze(HBvar{3,VarIDX(n_Var)}(:,:,HarmIDX(n_Harm)));
end
end
%#################### Opt_MixVec [MixVec NumTone]
    %harmindex   = [squeeze(HBvar{3,1}(1,1,HarmIDX))];
    %harmindex.'
HarmIDX%    [MixVec]
%Freq       [#df MixVec]
disp(['size(Freq): ' num2str(size(Freq))])
%#################### %Opt_Var    [Var]
VarIDX%     [Var]
HBout%      [Var MixVec]


%% ###############################
    otherwise
end


%% TEST (see Read_MDF_Func2)
if (0)

[flag_isfound y_IDX] = Buss_fmBasis_Func(Opt_MixVec(1,:), [1 0], 'fm_idx')

%####################
FileNam = 'SD513301_HD5ord_Test.mdf';
    file = fullfile(PATH.ADS_Data, FileNam)
    [Var_Indep, Var_Dep, Var_DepStruct] = Read_MDF_Func2(file);
%Var_Indep = 
%    'Pin'
%    [          1]
%    [1x81 double]
%    [         81]
%Var_Dep = 
%    'HD.HD.HB'    'aele_0.HD'
%    'HD_HD_HB'    'aele_0_HD'
%Var_DepStruct = 
%    {3x5 cell}    {3x13 cell}
%####################
Opt_HB      = '1D_Pin';
Opt_MixVec  = [1; 2; 3];
Opt_Var     = {'BEH_Vout' 'Vout_I' 'Vin'};
[Pin HarmIDX Freq VarIDX HBout] = Read_MDF_HB_Func(...
	Var_Indep, Var_Dep, Var_DepStruct, ...
    Opt_HB, Opt_MixVec, Opt_Var);
%HarmIDX =
%     2     3     4
%Freq =  1.0e+009 *
%    2.0000    4.0000    6.0000
%VarIDX =
%     3     4     5
%HBout = 
%    [81x1 double]    [81x1 double]    [81x1 double]
%    [81x1 double]    [81x1 double]    [81x1 double]
%    [81x1 double]    [81x1 double]    [81x1 double]
    
%####################
FileNam = 'AsymTest_PA2_IMD_3ord7HD_10ptdec.mdf';
file = fullfile(PATH.ADS_Data, FileNam)
[Var_Indep, Var_Dep, Var_DepStruct] = Read_MDF_Func2(file);
%Var_Indep = 
%    'df_swp'          'Pin'       
%    [           1]    [         1]
%    [1x141 double]    [1x4 double]
%    [         141]    [         4]
%Var_Dep = 
%    'df_SWP.IMD.IMD.HB'    'aele_0.IMD'
%    'df_SWP_IMD_IMD_HB'    'aele_0_IMD'
%Var_DepStruct = 
%    {3x6 cell}    {3x8 cell}
%Var_DepStruct{1}
%  Columns 1 through 5
%    'harmindex'          'freq'               'Mix[1]'             'Mix[2]'             'Vout'           
%    [              0]    [              1]    [              0]    [              0]    [              3]
%    [141x4x35 double]    [141x4x35 double]    [141x4x35 double]    [141x4x35 double]    [141x4x35 double]
%  Column 6
%    'Vin'            
%    [              3]
%    [141x4x35 double]
%####################
Opt_HB      = '2D_df_Pin';
Opt_MixVec  = [-1 1; 2 -1; 1 0; 0 1; -1 2];
Opt_Var     = {'Vout' 'Vin'};
[Pin HarmIDX Freq VarIDX HBout] = Read_MDF_HB_Func(...
	Var_Indep, Var_Dep, Var_DepStruct, ...
    Opt_HB, Opt_MixVec, Opt_Var);
%HarmIDX =
%     2     5     6     7     8
%size(Freq)
%   141     5(COLS for each Var in HBout)
%VarIDX =
%     5     6
%HBout
%    [141x4 double]    [141x4 double]
%    [141x4 double]    [141x4 double]
%    [141x4 double]    [141x4 double]
%    [141x4 double]    [141x4 double]
%    [141x4 double]    [141x4 double]

end