function [x xDelta xParams y] ...
    = Read_VSAmat_Func(FileNam, FileType, Opt_Debug)

if ~exist('Opt_Debug','var')
    Opt_Debug = 1;
end

%% ######################### VarIDX Dep on FileType
switch FileType
    %----------------------------- Time ------------------------------
    case{'Record', 1}
        %Y not same# pts
        %CirShift_Pts 	= -49;
        %Path_DS_Data    = 'Data\SpecGram_1k1M_Switch';
        %Path_DS_Data    = 'Data\SpecGram_1k1M';                %NumSeg = 11;
        %Path_DS_Data    = 'Data\2Tone_2Ghz_df10k_-10dBm100Mhz';
        %Path_DS_Data    = 'Data\SpecGram_SEQsp3M1seg';
        %Path_DS_Data    = 'Data\SpecGram';
        xParams = {'FreqValidMax' 'FreqValidMin' 'InputCenter' 'InputRange'};
        VarIDX_XDELTA 	= 'XDelta';
        VarIDX_Y      	= 'Y';
        %VarIDX          = [1 2 3 4];% [FreqValidMax FreqValidMin InputCenter InputRange]
        %VarIDX_XDELTA 	= 7;
        %VarIDX_Y      	= 11;
    case{2}
    	%'Data\DS_df20k';
        VarIDX_XDELTA 	= 4;
        VarIDX_Y     	= 7;
    case{'Trace_wHeader', 3}
        %3 'Data\SpecGram_Trace\'  NumSeg = 4;
        %File_VarIndex_x    = [55 51 5 6];
        %CirShift_Pts     	= -6; %-5;
        %[FreqValidMax FreqValidMin]
        VarIDX          = [6 7];
        VarIDX_XDELTA 	= 55;
        VarIDX_Y      	= 59;
    case{'Trace_DEMODtimeRaw_wHeader'}
        xParams = {'FreqValidMax' 'FreqValidMin' 'InputCenter' 'InputRange' 'ZeroPadding' 	'InputBlockSize'        'XStart' 'T_XLeft' 'T_XRight' 'TimeSec'};
        VarIDX_XDELTA 	= 'XDelta';
        VarIDX_Y      	= 'Y';
        %VarIDX         = [6 7 9 12 62      8       58 34 36 44];%DemodType=5     WindowType=55 
        %VarIDX_XDELTA 	= 56;
        %VarIDX_Y      	= 60;
    case{'Trace_DEMODtime_wHeader'}
        xParams = {'FreqValidMax' 'FreqValidMin' 'InputCenter' 'InputRange' 'ZeroPadding' 	'InputBlockSize'        'XStart' 'T_XLeft' 'T_XRight' 'TimeSec'};
        VarIDX_XDELTA 	= 'XDelta';
        VarIDX_Y      	= 'Y';        
        %VarIDX         = [6 7 9 12 59      8       55 34 36 44];%DemodType=5     WindowType=52 
        %VarIDX_XDELTA 	= 53;
        %VarIDX_Y      	= 57;
    case{'StimResp', 4}
       	VarIDX_fs       = 3;
        VarIDX_Stim    	= 5;
        VarIDX_Resp     = 2;
    %----------------------------- Spectrum ------------------------------
    case{'Trace_DEMODspec_wHeader'}
        xParams = {'FreqValidMax' 'FreqValidMin' 'InputCenter' 'InputRange' 'ZeroPadding'	'AliasedData' 'ResBW'	'XStart' 'T_XLeft' 'T_XRight' 'TimeSec'};
        VarIDX_XDELTA 	= 'XDelta';
        VarIDX_Y      	= 'Y';        
        %VarIDX         = [7 8 9 12 60      1 16    56 35 37 45];%DemodType=6     WindowType=53
        %VarIDX_XDELTA 	= 54;
        %VarIDX_Y      	= 58;
    case{'Trace_DEMODcorr_wHeader'}
        xParams = {'FreqValidMax' 'FreqValidMin' 'InputCenter' 'InputRange'                 'AliasedData'           'XStart' 'T_XLeft' 'T_XRight' 'TimeSec'};
        VarIDX_XDELTA 	= 'XDelta';
        VarIDX_Y      	= 'Y';        
end

%% ######################### Read Var
FileInfo = who('-file', FileNam);% instead of whos, which also needs FileInfo = {FileInfo.name};
    
for n = 1 : size(xParams,2)
    temp            = load(FileNam, xParams{1,n});
    xParams{2,n}    = temp.(xParams{1,n});
    xParams{2,n}    = double( xParams{2,n} );
end
    if(Opt_Debug)
        %FileInfo
        xParams
    end

switch FileType
    case{'StimResp'}
        {FileInfo{VarIDX_fs} FileInfo{VarIDX_Stim} FileInfo{VarIDX_Resp}}
        fs	= load(FileNam, FileInfo{VarIDX_fs});
        x	= load(FileNam, FileInfo{VarIDX_Stim});
        y 	= load(FileNam, FileInfo{VarIDX_Resp});
        xDelta	= 1 / fs.(FileInfo{VarIDX_fs});
        x       = x.(FileInfo{VarIDX_Stim}).';
        y       = y.(FileInfo{VarIDX_Resp}).';
        if(Opt_Debug)
            {FileInfo{VarIDX_fs}        FileInfo{VarIDX_Stim}   FileInfo{VarIDX_Resp};
            xDelta                     length(x)               length(y)}
        end
        y = double(y);
    otherwise
        xDelta 	= load(FileNam, VarIDX_XDELTA);
        x       = load(FileNam, VarIDX_Y);
        xDelta 	= xDelta.(VarIDX_XDELTA);
        x       = x.(VarIDX_Y);
        if(Opt_Debug)
            {VarIDX_XDELTA	VarIDX_Y;
             xDelta      	length(x)}
        end
end
        xDelta = double(xDelta);
        x = double(x);

%% TEST
if(0)
    
xParams = cell([2 length(VarIDX)]);
for n = 1 : length(VarIDX)
    temp    = load(FileNam, FileInfo{VarIDX(n)});
    temp    = temp.(FileInfo{VarIDX(n)});
    xParams{1,n} = FileInfo{VarIDX(n)};
    xParams{2,n} = temp;
end

        xDelta 	= load(FileNam, FileInfo{VarIDX_XDELTA});
        x       = load(FileNam, FileInfo{VarIDX_Y});
        xDelta 	= xDelta.(FileInfo{VarIDX_XDELTA});
        x       = x.(FileInfo{VarIDX_Y});
        if(Opt_Debug)
            {FileInfo{VarIDX_XDELTA}	FileInfo{VarIDX_Y};
            xDelta                     length(x)}
        end
end