function [Indep_Var Block_DepVar] = Write_MemModel_MdfCell(...
    IndepVar, Block, Opt)
%IndepVar   = {'Name'; 
%               type(0-int/1-float); 
%               [COL]}
%Block	= {'Name'; 
%           type; 
%           ModelOrd_MAX; 
%           [ModelOrd COL]; 
%           [[ROW]
%            [...]
%            (ModelOrd, #<ModelOrd_MAX)]}
%Opt    =   'tf_zpk'    : Indep_Var{3,2} created from [ModelOrd COL]
%           'FreqResp'  : 

%if ~exist('Opt', 'var')
%    Opt = 'tf_zpk';
%end

%% ############################### Indep_Var
Indep_Var = IndepVar;
switch Opt
    %++++++++++++++++++++
    case {'tf_zpk'}% Cat Model_Ord as string into Indep_Var{3,2}
        nROW = size(Block{4,1}, 1);
        nCOL = size(Block, 2);
        for nINNER = 1 : nROW
            ModelOrd_STR = [];
            for nBLK = 1 : nCOL
                ModelOrd_STR = [ModelOrd_STR num2str(Block{4,nBLK}(nINNER,1))];
            end
            ModelOrd(nINNER,1) = str2num(ModelOrd_STR);
            %ModelOrd(nINNER,1) = str2num([num2str(ord_za) num2str(ord_Numer) num2str(ord_Denom)])
        end
        Indep_Var{3,2} = ModelOrd;
    %++++++++++++++++++++
    case {'FreqResp'}
    %++++++++++++++++++++
    otherwise
end
Indep_Var

%% ############################### Dep_Var
for nBLK = 1 : size(Block, 2)
    Block{5,nBLK} = [Block{5,nBLK}    zeros(1, (Block{3,nBLK}+1) - length(Block{5,nBLK}))];
    Dep_Var	= {};
    for n_Dep = 1 : (Block{3,nBLK}+1)
        n_ord = n_Dep - 1;
        %[nBLK	n_Dep]
        Dep_Var{1,n_Dep}	= [Block{1,nBLK} '_' num2str(n_ord)];
        Dep_Var{2,n_Dep}	= Block{2,nBLK};
        Dep_Var{3,n_Dep}	= Block{5,nBLK}(:,n_Dep);
    end
    Block_DepVar{1,nBLK} = Block{1,nBLK};
    Block_DepVar{2,nBLK} = Dep_Var;
    Dep_Var
end

%%  Test
if (0)

%where var*Type can be the token:
%0 or int
%1 or real
%2 or string
%Type bVar*Type can be one of the above as well as:
%3 or complex
%4 or boolean
%5 or binary
%6 or octal
%7 or hexadecimal
%8 or byte16 

ord_ADS_za   	= 9;
ord_ADS_Numer 	= 50;
ord_ADS_Denom 	= 5;
%######################
nINNER     = 1;
ord_za   	= 5;
ord_Numer 	= 18;
ord_Denom 	= 3;
ModelOrd(nINNER,1) = str2num([num2str(ord_za) num2str(ord_Numer) num2str(ord_Denom)])
    %+++++++++++
z_I =           [    0.3971   -1.3527   -0.2061    6.4954];
z_Q =           [  -12.0627    0.1587    0.7598   -2.5166];
z = []; 
z(nINNER,:) = [z_I+j*z_Q     zeros(1, (ord_ADS_za+1)-length(z_I))];
    %+++++++++++
a_I = [[0 0]    [ 0.5037   -3.3382    7.4591  -21.4826]];
a_Q = [[0 0]    [-0.1233    1.2339   -5.1084   14.5312]];
a = [];
a(nINNER,:) = [a_I+j*a_Q     zeros(1, (ord_ADS_za+1)-length(a_I))];
    %+++++++++++
b_xs = [725.4414e-126   -77.1084e-117    -1.7681e-108   -31.7683e-102  -910.8473e-096    10.6137e-087 ...
   280.5783e-081     4.3156e-072   123.7891e-066   232.8600e-060     7.3124e-051     1.3552e-045 ...
    79.3352e-039   -11.5065e-033   217.8232e-027  -105.0581e-021  -157.1909e-015     1.5138e-009 ...
  -198.2560e-006];
Numer(nINNER,:) = [fliplr(b_xs)     zeros(1, (ord_ADS_Numer+1)-length(b_xs))];
    %+++++++++++
a_xs = [2.9146e-021   125.5782e-015     9.0087e-009   295.1262e-006];
Denom(nINNER,:) = [fliplr(a_xs)     zeros(1, (ord_ADS_Denom+1)-length(a_xs))];
%######################
Indep_Var   = {'model_nam'   	'model_ord'; ...
                0            	0;...
                0               ModelOrd};
Indep_Var% celldisp(Indep_Var)
%######################
Block_DepVar = {};
%+++++++++++
Dep_Var     = {};
for n_Dep = 1 : (ord_ADS_za+1)
    n_ord = n_Dep - 1;
    Dep_Var{1,n_Dep}	= ['z_' num2str(n_ord)];
    Dep_Var{2,n_Dep}	= 3;
	Dep_Var{3,n_Dep}	= z(:,n_Dep);
end
Dep_Var% celldisp(Dep_Var)
nBLK = 1;
Block_DepVar{1,nBLK} = 'z';
Block_DepVar{2,nBLK} = Dep_Var;
    %+++++++++++
Dep_Var     = {};
for n_Dep = 1 : (ord_ADS_za+1)
    n_ord = n_Dep - 1;
    Dep_Var{1,n_Dep}	= ['a_' num2str(n_ord)];
    Dep_Var{2,n_Dep}	= 3;
	Dep_Var{3,n_Dep}	= a(:,n_Dep);
end
Dep_Var% celldisp(Dep_Var)
nBLK = 2;
Block_DepVar{1,nBLK} = 'a';
Block_DepVar{2,nBLK} = Dep_Var;
    %+++++++++++
Dep_Var     = {};
for n_Dep = 1 : (ord_ADS_Numer+1)
    n_ord = n_Dep - 1;
    Dep_Var{1,n_Dep}	= ['NP_' num2str(n_ord)];
    Dep_Var{2,n_Dep}	= 3;
	Dep_Var{3,n_Dep}	= Numer(:,n_Dep);
end
Dep_Var% celldisp(Dep_Var)
nBLK = 3;
Block_DepVar{1,nBLK} = 'NP';
Block_DepVar{2,nBLK} = Dep_Var;
    %+++++++++++
Dep_Var     = {};
for n_Dep = 1 : (ord_ADS_Denom+1)
    n_ord = n_Dep - 1;
    Dep_Var{1,n_Dep}	= ['DP_' num2str(n_ord)];
    Dep_Var{2,n_Dep}	= 3;
	Dep_Var{3,n_Dep}	= Denom(:,n_Dep);
end
Dep_Var% celldisp(Dep_Var)
nBLK = 4;
Block_DepVar{1,nBLK} = 'DP';
Block_DepVar{2,nBLK} = Dep_Var;
%######################

end