function [] = Write_S2D_Func(Freq, Snp_Freq, PinFc, Pin, S21_Pin, ...
    File_Save, Opt_Freq, Opt_Pin)

switch Opt_Freq{1}
    case {'KHZ'}
        Freq_Scale = 1e3
    case {'MHZ'}
        Freq_Scale = 1e6
    case {'GHZ'}
        Freq_Scale = 1e9
    otherwise
        Freq_Scale = 1
end
OptStr_Freq     = ['#AC (' Opt_Freq{1}	' S ' Opt_Freq{2}  ' R ' Opt_Freq{3}	' FC 1 0)']
FormatStr_Freq  = ['% F              n11x n11y                        n21x n21y                     n12x n12y                       n22x n22y']
%++++++++++++++++++++++++++++++
OptStr_Pin      = ['#AC (' Opt_Pin{1}	' S ' Opt_Pin{2}    ' R ' Opt_Pin{3}    ')']
FormatStr_PinFc = ['% F']
FormatStr_Pin   = ['% PIN          	 n21x n21y']

%% ############################### small sig AC
dlmwrite(File_Save, '', ...
    'delimiter','', 'newline','unix')
dlmwrite(File_Save, 'BEGIN ACDATA', ...
    'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save, OptStr_Freq, ...
    'delimiter','', 'newline','unix', '-append')
%++++++++++++++++++++++++++++++
dlmwrite(File_Save, FormatStr_Freq, ...
    'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save, [Freq/Freq_Scale,	real(Snp_Freq{1}), imag(Snp_Freq{1}), ...
                                        real(Snp_Freq{2}), imag(Snp_Freq{2}), ...
                                        real(Snp_Freq{3}), imag(Snp_Freq{3}), ...
                                        real(Snp_Freq{4}), imag(Snp_Freq{4}) ], ...
    'delimiter','\t', 'newline','unix', 'precision','%10.6f', '-append')
    pause(5) % dlmwrite takes long time, returns wo/finish writing
dlmwrite(File_Save, 'END ACDATA', ...
    'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save, ' ', ...
    'delimiter','', 'newline','unix', '-append')

%% ############################### lg sig PwrSweep
dlmwrite(File_Save, 'BEGIN GCOMP7', ...
    'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save, OptStr_Pin, ...
    'delimiter','', 'newline','unix', '-append')
%++++++++++++++++++++++++++++++
dlmwrite(File_Save, FormatStr_PinFc, ...
    'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save, PinFc/Freq_Scale, ...
    'delimiter','', 'newline','unix', '-append')
%++++++++++++++++++++++++++++++
dlmwrite(File_Save, FormatStr_Pin, ...
    'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save, [Pin,	real(S21_Pin), imag(S21_Pin)], ...
	'delimiter','\t', 'newline','unix', 'precision','%10.6f', '-append')
    pause(3) % dlmwrite takes long time, returns wo/finish writing
dlmwrite(File_Save, 'END GCOMP7', ...
    'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save, ' ', ...
    'delimiter','', 'newline','unix', '-append')

%% ############################### Test
if(0)
Char= 'FreqResp';
FileNam1 = 'SD513301_2000Mhz8Mhz_-20dBmAtt10_100hz_8001pts10ms_LSNA.s2p';
File_Load = fullfile(Path_PNA_Data, Char, FileNam1)
[Freq Snp_Freq] = Read_SnP_Func(File_Load, 2,'dB_dB','ADSPNA-2port');
%++++++++++++++++++++++++++++++
%FileNam1 = 'SD513301_2000Mhz8Mhz_-20dBmAtt10_100hz_8001pts10ms_LSNA.mat';
%File_Load = fullfile(Path_PNA_Data, FileNam1)
    %Snp_Freq = load(File_Load) %, 'Freq', 'S11_dB','S11_Pha', 'S21_dB','S21_Pha', 'S12_dB','S12_Pha', 'S22_dB','S22_Pha')

Char= 'AMPM';
FileNam2 = 'SD513301_2000Mhz_-28dBm12dBmAtt0_100hz_401pts10ms_LSNA.s2p';
File_Load = fullfile(Path_PNA_Data, Char, FileNam2)
[Pin Snp_Pin] = Read_SnP_Func(File_Load, 2,'dB_dB','ADSPNA-2port');
%++++++++++++++++++++++++++++++
%FileNam2 = 'SD513301_2000Mhz_-28dBm12dBmAtt0_100hz_401pts10ms_LSNA.mat';
%File_Load = fullfile(Path_PNA_Data, FileNam2)
    %S21_Pin = load(File_Load) %, 'Pin', 'S11_dB','S11_Pha', 'S21_dB','S21_Pha', 'S12_dB','S12_Pha', 'S22_dB','S22_Pha')

Char= 'Model';
Ver = 'v1'
File_Save = fullfile(Path_PNA_Data, Char, [DUT '_' Ver '.s2d'])
%++++++++++++++++++++++++++++++
%File_Save = fullfile(Path_PNA_Data, [DUT '.s2d'])

PinFc   = 2e9; 
fc_idx  = find( Freq == PinFc )
    % check Mag/Pha continuity betw AMPM and FreqResp
    [Snp_Pin{2}(1)	Snp_Freq{2}(fc_idx)]
S21_Pin = Snp_Pin{2} - Snp_Freq{2}(fc_idx);
Opt_Freq    = {'MHZ' 'DB' '50'};
Opt_Pin     = {'MHZ' 'DBM DB' '50'};
Write_S2D_Func(Freq, Snp_Freq, PinFc, Pin, S21_Pin, ...
    File_Save, Opt_Freq, Opt_Pin)



%%############################### write PNA .S2D
File_Save = fullfile(Path_PNA_Data, [DUT '.s2d'])
dlmwrite(File_Save,'', 'delimiter','', 'newline','unix')
dlmwrite(File_Save,'BEGIN ACDATA', 'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save,'#AC (MHZ S DB   R 50   FC 1 0)', 'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save,'% F              n11x n11y                        n21x n21y                     n12x n12y                       n22x n22y', 'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save,[PNA_FreqResp.Freq/1e6,  PNA_FreqResp.S11_dB, PNA_FreqResp.S11_Pha, ...
                                            PNA_FreqResp.S21_dB, PNA_FreqResp.S21_Pha, ...
                                            PNA_FreqResp.S12_dB, PNA_FreqResp.S12_Pha, ...
                                            PNA_FreqResp.S22_dB, PNA_FreqResp.S22_Pha], 'delimiter','\t', 'newline','unix', 'precision','%10.6f', '-append')
dlmwrite(File_Save,'END ACDATA', 'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save,' ', 'delimiter','', 'newline','unix', '-append')
    pause(5) % dlmwrite takes long time, returns wo finishing writing
dlmwrite(File_Save,'BEGIN GCOMP7', 'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save,'#AC (MHZ S DBM DB    R 50)', 'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save,'% F', 'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save,2000, 'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save,'% PIN             n21x n21y', 'delimiter','', 'newline','unix', '-append')
    % check Mag/Pha continuity betw AMPM and FreqResp
    [PNA_AMPM.S21_dB(1)     PNA_FreqResp.S21_dB(fc_idx)]
    [PNA_AMPM.S21_Pha(1)    PNA_FreqResp.S21_Pha(fc_idx)]
dlmwrite(File_Save,[PNA_AMPM.Pin,   PNA_AMPM.S21_dB  - PNA_FreqResp.S21_dB(fc_idx), ...
                                    PNA_AMPM.S21_Pha - PNA_FreqResp.S21_Pha(fc_idx)], 'delimiter','\t', 'newline','unix', 'precision','%10.6f', '-append')
dlmwrite(File_Save,'END GCOMP7', 'delimiter','', 'newline','unix', '-append')
dlmwrite(File_Save,' ', 'delimiter','', 'newline','unix', '-append')

end