function [y2] = Interp1_Func( ...
    x1, y1, x2, Opt, ...
    FigMAT, PlotOpt)
% x1 -> x
% x2 -> xExtrp
% y1 -> y --(RI Interp)--> yExtrp -> y2
% Opt.xScale
% Opt.yFormat
% Opt.Meth = {'nearest' 'linear' 'spline' 'pchip' }

%% ########################### Pre Proc
switch Opt.xScale
    %-------------------------
    case{'xLIN'}
        x           = x1;
        xExtrp      = x2;
    %-------------------------
    case{'xLOG'}
        [x]         = FreqAxis_Func(x1,	struct('LindB','dB'));
        [xExtrp]    = FreqAxis_Func(x2,	struct('LindB','dB'));
    %-------------------------
end

switch Opt.yFormat
    %-------------------------
    case{'MA'}
        y = Lin2MA_MA(y1,'UnWrap','rad');
    %-------------------------
    case{'dB'}
        y = Lin2dB_dB(y1,'UnWrap','rad');
    %-------------------------
    otherwise% case{'RI'}
        y = y1;
end

%% ########################### Interp1
%switch Opt.xScale
    %########################### 
%    case {'LPF'}
    %########################### 
%    case {'simple'}
    yExtrp_1 = interp1(x, real(y),	xExtrp, Opt.Meth,'extrap');
    yExtrp_2 = interp1(x, imag(y),	xExtrp, Opt.Meth,'extrap');
%end

%% ########################### Post Proc
switch Opt.yFormat
    %-------------------------
	case{'MA'}
    	y2 = MA2Lin_RI( yExtrp_1 + j*yExtrp_2, 'rad');
    %-------------------------
	case{'dB'}
        y2 = dB2Lin_RI( yExtrp_1 + j*yExtrp_2, 'rad');
    %-------------------------
    otherwise% case{'RI'}
        y2 = yExtrp_1 + j*yExtrp_2;
end

%% ########################### Plot
if exist('FigMAT', 'var')
    
MethCEL = {'nearest' 'linear' 'spline' 'pchip' };
for nMETH = 1 : length(MethCEL)
	if isequal(Opt.Meth, MethCEL{nMETH})
        break
	end
end

n_idx =1;
%++++++++++ y1
if(FigMAT(1,1) > 0)
    plot_Sio_Func(x, y1,...
        'RI','RI-Lin', figure(FigMAT(1,2)),'Xlin',['-ko' ], ...
        [],[],[],{},['Data'])
end
if(FigMAT(1,2) > 0)
	plot_Sio_Func(x, Lin2MA_MA(y1), ...
        'MA','RI-Lin', figure(FigMAT(1,1)),'Xlin',['-ko' ], ...
        [],[],[],{},['Data'])
end
if(FigMAT(1,3) > 0)
	plot_Sio_Func(x, Lin2dB_dB(y1), ...
        'dB','RI-Lin', figure(FigMAT(1,3)),'Xlin',['-ko' ], ...
        [],[],[],{},['Data'])
end
%++++++++++ y2
if(FigMAT(2,1) > 0)
	plot_Sio_Func(xExtrp, y2,...
        'RI','RI-Lin', figure(FigMAT(2,2)),'Xlin',['-' PlotOpt.colors(nMETH) PlotOpt.marker(n_idx)], ...
        [],[],[],{},['Interp1 ' Opt.Meth])
end
if(FigMAT(2,2) > 0)
	plot_Sio_Func(xExtrp, Lin2MA_MA(y2), ...
        'MA','RI-Lin', figure(FigMAT(2,1)),'Xlin',['-' PlotOpt.colors(nMETH) PlotOpt.marker(n_idx)], ...
        [],[],[],{},['Interp1 ' Opt.Meth])
end
if(FigMAT(2,3) > 0)
	plot_Sio_Func(xExtrp, Lin2dB_dB(y2), ...
        'dB','RI-Lin', figure(FigMAT(2,3)),'Xlin',['-' PlotOpt.colors(nMETH) PlotOpt.marker(n_idx)], ...
        [],[],[],{},['Interp1 ' Opt.Meth])
end

end
%% Test
if(0)

%	pts_dec = 10;% 50
%	[x2] = freqspace_Func(x1(1), x1(end), pts_dec,'StartStop_Dec');

%MethCEL = {'nearest' 'linear' 'spline' 'pchip' };
%count = 0;
%for nMETH = 2 : 3
%    Opt_METH = MethCEL{nMETH}
%    if (count == 0)
%        [y2] = Interp1_Func(x1, y1, Opt_METH, ...
%            x2, {'MA' 'simple'}, [300 400; 300 400], PlotOpt.colors, PlotOpt.marker);
%    else
%        [y2] = Interp1_Func(x1, y1, Opt_METH, ...
%            x2, {'MA' 'simple'}, [0 0; 300 400], PlotOpt.colors, PlotOpt.marker);
%    end
%    count = count + 1;
%end

Opt_METH = 'linear';
H3L_Mag_Itp = interp1(Lin2dB(SigGen_Seg_dfim3)/20,abs(H3L_avg), Lin2dB(SigGen_Seg_df)/20,Opt_METH,'extrap'); % );% 
H3H_Mag_Itp = interp1(Lin2dB(SigGen_Seg_dfim3)/20,abs(H3H_avg), Lin2dB(SigGen_Seg_df)/20,Opt_METH,'extrap'); % );%
H3L_Pha_Itp = interp1(Lin2dB(SigGen_Seg_dfim3)/20,angle(H3L_avg)/pi*180, Lin2dB(SigGen_Seg_df)/20,Opt_METH,'extrap'); % );% 
H3H_Pha_Itp = interp1(Lin2dB(SigGen_Seg_dfim3)/20,angle(H3H_avg)/pi*180, Lin2dB(SigGen_Seg_df)/20,Opt_METH,'extrap'); % );%
figure(fig_Vec3(1))     %figure(fig_Vec1(1))
semilogx( SigGen_Seg_df,abs(H3L_Mag_Itp),'-co', SigGen_Seg_df,abs(H3H_Mag_Itp),'-mx'); grid on; hold on;
figure(fig_Vec3(2))     %figure(fig_Vec1(2))
semilogx( SigGen_Seg_df,H3L_Pha_Itp,'-co', SigGen_Seg_df,H3H_Pha_Itp,'-mx'); grid on; hold on;

end