function [PATH, PlotOpt] = Matlab_Settings(MatlabPC)

format;     format compact;
%% ############################### PlotOpt
%disp(' PLOT STEPS ')
%disp(' Figure, Subplot/MulitpleAxis ')
%disp(' Plot, MarkerColor ')
%disp(' Title, Label, Legend ')
%disp(' Grid/AxisLimits ')

PlotOpt.df_dBRef    = 1e3;% 1e3;%Ref to 1KHz% 
%-----------------------------------------
PlotOpt.colors      = repmat(['kbrmgcy'],               1,6);
PlotOpt.marker1     = ['x' '+' '*' '^' 'v' '<'];
PlotOpt.marker2     = ['o' 'd' 's' 'p' 'h' '>'];
PlotOpt.marker      = repmat([PlotOpt.marker1   PlotOpt.marker2],	1,4);
PlotOpt.marker1     = repmat(PlotOpt.marker1,                       1,4);
PlotOpt.marker2     = repmat(PlotOpt.marker2,                       1,4);
%-----------------------------------------
PlotOpt.Ln_Width    = 2;
PlotOpt.Mkr_Size    = 14;
PlotOpt.Font_Name   = 'Times';
PlotOpt.Font_Size   = 30;
PlotOpt.Font_Size_Leg = 24;
PlotOpt.Font_Weight	= 'normal';
%PlotOpt.Ln_Width    = 1;%       default width = 1
%PlotOpt.Mkr_Size    = 6;%       default size = 6
%PlotOpt.Font_Size   = 10;%      default size = 10
%PlotOpt.Font_Weight = 'normal';%  default = 'normal'
%-----------------------------------------

%% ############################### Common Settings
    PATH.Mydocu_PC  	= 'C:\Documents and Settings\jhu\My Documents\';% DODO Gromit
    PATH.Mydocu_PC2  	= 'C:\Documents and Settings\Administrator\My Documents\';% Athlon64X2
    PATH.Mydocu_NwkDrv	= 'Z:\';
    PATH.USB_HD         = 'E:\Users\Jhu\Gromit\';
    %-----------------------------------------
    %PATH.AFS_PC         = 'K:\';
    PATH.Locker_PC      = 'M:\users\jhu\';
    %PATH.AFS_Remote     = '/afs/.unity.ncsu.edu/users/j/jhu/';
    PATH.Locker_Remote  = '/afs/eos.ncsu.edu/lockers/research/ece/siames/users/jhu/';
    PATH.Coolum         = '/local/home/jhu/';% IP = 152.14.98.34
    %-----------------------------------------
    PATH.Cygwin	= 'C:\Documents and Settings\jhu\My Documents\lv8\cygwin\usr_local_freeda-1.3_simulator_projects';
               	 %'C:\cygwin\usr\local\freeda-1.3\simulator\projects';

%###### PATH.Locker	DataMeas DataProc
switch MatlabPC
    %-----------------------------------------
    case{'DODO' 'Gromit'    'DODO_USBhdr' 'Gromit_USBhdr'   'Athlon64X2'}
        PATH.Locker 	= PATH.Locker_PC;
    switch MatlabPC
        case {'DODO'}
        PATH.DataMeas  	= PATH.Mydocu_NwkDrv;
        PATH.DataProc 	= PATH.Mydocu_PC;
        case {'Gromit'}
        PATH.DataMeas  	= PATH.Mydocu_PC;
        PATH.DataProc 	= PATH.Mydocu_NwkDrv;
        case {'DODO_USBhdr'}
        PATH.DataMeas  	= PATH.USB_HD;
        PATH.DataProc 	= PATH.Mydocu_PC;
        case {'Gromit_USBhdr'}
        PATH.DataMeas  	= PATH.USB_HD;
        PATH.DataProc 	= PATH.Mydocu_PC;
        case {'Athlon64X2'}
        PATH.DataMeas  	= PATH.Mydocu_NwkDrv;
        PATH.DataProc 	= PATH.Mydocu_PC2;
    end
    %-----------------------------------------
    case{'Coolum'   'Closeshave' 'Grendel' 'Compute'}
        PATH.Locker 	= PATH.Locker_Remote;
    switch MatlabPC
        case {'Coolum'}
        PATH.DataMeas   = '-----';
        PATH.DataProc 	= PATH.Locker;% Code + Data
        %PATH.DataProc 	= PATH.Coolum;
        case {'Closeshave' 'Grendel' 'Compute'}
        PATH.DataMeas   = '-----';
        PATH.DataProc 	= PATH.Locker% Code + Data
    end
    %-----------------------------------------
end

    %----------------------------------------- Not influenced by MatlabPC
    PATH.PNA_NwkDrive   = '\\152.14.55.100\c$\Program Files\Agilent\Network Analyzer\Documents\Jhu\'; % 'Z:\';
    PATH.PNA_LocalDrive = 'C:\Program Files\Agilent\Network Analyzer\Documents\Jhu\';

%% ##############################################################
	PATH.MatlabSave     = '\lv8\';
	%----------------------------------------- 
  	PATH.VSA_Config     = '\Config\';
	PATH.VSA_Meas       = '\Data\';
    PATH.VSA_Save       = '\lv8\Data_VSA\';
	PATH.Data           = '\lv8\Data\';
    %----------------------------------------- PATH.VSAProcSave
	PATH.FREEDA_Models	= 'freeda_v13\models\';
  	PATH.FREEDA_Data	= 'freeda_v13\data';
    PATH.ADS_Models     = '\ads_models';
    %----------------------------------------- Freeda_Plot

%###### PATH.MatlabSave	VSA_Config      VSA_Meas    VSA_Save Data
%###### PATH.           FREEDA_Models   FREEDA_Data ADS_Models
switch MatlabPC
	case {'Coolum' 'Closeshave' 'Grendel' 'Compute'}
        PATH.MatlabSave	= strrep(PATH.MatlabSave,   '\','/');
        %----------------------------------------- 
        PATH.VSA_Config	= strrep(PATH.VSA_Config,   '\','/');
        PATH.VSA_Meas	= strrep(PATH.VSA_Meas,     '\','/');
        PATH.VSA_Save	= strrep(PATH.VSA_Save,     '\','/');
        PATH.Data   	= strrep(PATH.Data,         '\','/');
        %-----------------------------------------
        PATH.FREEDA_Models	= strrep(PATH.FREEDA_Models,	'\','/');
        PATH.FREEDA_Data 	= strrep(PATH.FREEDA_Data,      '\','/');
        PATH.ADS_Models 	= strrep(PATH.ADS_Models,       '\','/');
end
switch MatlabPC
	case {'Coolum'}
        PATH.MatlabSave     = fullfile(PATH.Coolum, 	PATH.MatlabSave);% Local Save-Ouput
    otherwise
        %case {'DODO'}
        %case {'Closeshave' 'Grendel' 'Compute'}
        PATH.MatlabSave     = fullfile(PATH.DataProc, 	PATH.MatlabSave); 
end
    %----------------------------------------- PATH.VSAProcSave
  	PATH.VSA_Config     = fullfile(PATH.DataMeas, 	PATH.VSA_Config); 
 	PATH.VSA_Meas       = fullfile(PATH.DataMeas, 	PATH.VSA_Meas); 
 	PATH.VSA_Save       = fullfile(PATH.DataProc, 	PATH.VSA_Save); 
	PATH.Data           = fullfile(PATH.DataProc, 	PATH.Data); 
    %----------------------------------------- Freeda_Plot
	PATH.FREEDA_Models	= fullfile(PATH.Locker, PATH.FREEDA_Models);
	PATH.FREEDA_Data	= fullfile(PATH.Locker, PATH.FREEDA_Data);
	PATH.ADS_Models     = fullfile(PATH.Locker, PATH.ADS_Models);

    