function [V_Spec f_Spec t_Spec ...
    TIDX_OFF TIDX_ON] = Spectr_StepResp_Func(T, V, ...
    Fs, Fresoln, WindIncre, ...
    WindType, WindLen, WindPadFact, ...
    Opt)
% T: rowVEC
% V: rowVEC
% WindLen   = [glength      hlength     N=FFT-WindLen]
% WindType 	= {'Hamming'    'Hamming'};
% Opt = {'TStartWindow' 'TF'	T_LO T_HI     FigVEC(1) subplot   	TFmeth TFview};
% Opt = {{'TStartWindow' 'TF'}	[TswitchOFF TswitchON] 	[FigVEC(1) 1]  TFmeth TFview};
% Opt = {1                          2                       3               4    	5};

%======================================== Fs
if( iscell(Fs) )% Scope Data: Calc Fs
    T_Div   = Fs{1};
    RecLen  = Fs{2};
    Ts	= T_Div / (RecLen/15);
    Fs  = 1/Ts;
else%------------------------------
    Ts	= 1/Fs;
end

%======================================== FFT-WindLen
if( isempty(WindLen) )
    WindLen = Fs / (Fresoln/2)% (T = 1/Fresoln) / Ts
end
if( IsEven_Func( WindLen ) )
    Lh      = (WindLen)/2;
    offset  = 1;
else
    Lh      = (WindLen-1)/2;% round(N/2)-1
    offset  = 0;
end

	disp('%======================================== Fs FFT-WindLen')
    [Fs   	Fresoln     Fs/WindIncre] / Fref_Func(Fs)% in Mhz
    [1      WindLen   	WindIncre]% in #SamplePts
 	disp('%--------------- T_LO T_HI')
%% 1-2500=OFF   2501-5000   ON=5001-7500
WindLen_OffsetFct = 0;% 
switch Opt{1}{1}
	%========================================
    case{'TStartWindow'}
    TswitchOFF	= Opt{2}(1);
    TIDX_OFF    = find(T >= TswitchOFF, 1, 'first');
        TIDX_LO = TIDX_OFF - WindLen + 1;% TIDX_OFF - TIDX_LO + 1 = WindLen
        T_LO    = T( TIDX_LO );
        %T_LO  	= TswitchOFF-Ts - (WindLen*(1+WindLen_OffsetFct))*Ts;
        %TIDX_LO = find(T >= T_LO, 1, 'first');
	tSTART  = TIDX_LO-1 + Lh+1;% tSTART - TIDX_LO + 1 = Lh+1
	switch Opt{1}{2}
        %------------------------------------------
        case{'TF'}% Data[TswitchOFF - WindLen, TswitchON  + WindLen]
            TswitchON	= Opt{2}(2);
            TIDX_ON     = find(T <= TswitchON, 1, 'last');
            tSTOP       = TIDX_ON-1 + Lh+1;% tSTOP - TIDX_ON + 1 = Lh+1
            tSTOP       = tSTART + WindIncre * ceil(((tSTOP-1) - tSTART + 1) /WindIncre);
            TIDX_ON     = tSTOP - (Lh+1) + 1; 
            %ON-1 - (OFF+1) + 1 = WindIncre * #
            %TIDX_ON     = TIDX_OFF+1 + WindIncre * ceil(((TIDX_ON-1) - (TIDX_OFF+1)) /WindIncre);
            TswitchON   = T( TIDX_ON );
                TIDX_HI = TIDX_ON-1 + WindLen;% TIDX_HI - TIDX_ON + 1 = WindLen
                T_HI    = T( TIDX_HI );
                %T_HI  	= TswitchON  + (WindLen*(1+WindLen_OffsetFct) - 1)*Ts;
                %TIDX_HI = find(T <= T_HI, 1, 'last');
            Tvec = [T_LO    	TswitchOFF+Ts	TswitchON; ...
                    TswitchOFF  TswitchON-Ts   	T_HI] / Tref_Func(Ts)% uS
            TIDX = [TIDX_LO  	TIDX_OFF+1      TIDX_ON; ...
                    TIDX_OFF  	TIDX_ON-1       TIDX_HI]% #SamplePts
            TIDX(2,:) - TIDX(1,:) + 1% [(TIDX_OFF - TIDX_LO + 1)  (TIDX_ON-TIDX_OFF-1) (TIDX_HI - TIDX_ON + 1)]
     	%------------------------------------------
        case{'FFT'}% Data[TswitchOFF - WindLen, TswitchOFF]
         	TIDX_HI = TIDX_OFF;% TIDX_LO-1 + WindLen;
           	T_HI    = TswitchOFF;% T(TIDX_HI);
        [T_LO                               T_HI] / Tref_Func(Ts)% uS
        [TIDX_LO                            TIDX_HI]% #SamplePts
     	%------------------------------------------
    end
    T = T(TIDX_LO : TIDX_HI);
    V = V(TIDX_LO : TIDX_HI);
        [length(V) (TIDX_HI - TIDX_LO + 1)]% #SamplePts
	Vmax = max(abs(V));
	Vmin = min(abs(V));
        figure( Opt{3}(1) )
        subplot(1,2, Opt{3}(2));
      	plot([T_LO          T_LO],     	[-Vmax Vmax]*1.5,       '-co');grid on; hold on;
    	plot([T_HI          T_HI],    	[-Vmax Vmax]*1.5,       '-co'); 
        switch Opt{1}{2}
            %---------------------
            case{'TF'}
            plot([TswitchOFF    TswitchOFF],[-Vmax Vmax]*1.25,   '-co');
            plot([TswitchON     TswitchON],	[-Vmax Vmax]*1.25,   '-co');
        end
	%========================================
    case{'All'}
	%========================================
    otherwise
end

%%
disp('%========================================')
switch Opt{1}{2}
    %========================================
    case{'FFTwind'}% Window[WindLen] in FreqDom
        t_Spec = [];
        [V_Spec f_Spec] = FFTwind_Func(Fs, Fresoln, WindType, WindPadFact);
    %========================================
    case{'FFT'}
        t_Spec = [];
        [V_Spec f_Spec] = FFT_Func(V, Fs, WindType, WindPadFact);
    %========================================
    case{'TF'}
        switch Opt{4}
            case{'sp'}%---------------------
                disp('Need edit')
            case{'sp2'}
            [V_Spec f_Spec t_Spec] = tf_sp2(V.', T, Fs, ...
                WindLen, WindIncre, WindType, WindPadFact, ...
                Opt{5}, 0);
            case{'spGram'}
            [V_Spec f_Spec t_Spec] = SpectroGram_Func(V.', T, Fs, ...
                WindLen, WindIncre, WindType,   WindPadFact);
            case{'wv'}%---------------------
            [V_Spec f_Spec t_Spec] = tf_wv(V.', T, Fs, ...
                WindLen, WindIncre,             WindPadFact, ...
                Opt{5}, 0);
            case{'wv2'}
            [V_Spec f_Spec t_Spec] = tf_wv2(V.', T, Fs, ...
                WindLen, WindIncre,             WindPadFact, ...
                Opt{5}, 0);
            case{'wv3'}
            [V_Spec f_Spec t_Spec] = tf_wv3(V.', T, Fs, ...
                WindLen, WindIncre,             WindPadFact, ...
                Opt{5}, 0);
            case{'wv_sp'}%---------------------
            [V_Spec f_Spec t_Spec] = tf_wv_sp(V.', T, Fs, ...
                WindLen, WindIncre, WindType,   WindPadFact, ...
                Opt{5}, 0);
            case{'wv_sp2'}
            [V_Spec f_Spec t_Spec] = tf_wv_sp2(V.', T, Fs, ...
                WindLen, WindIncre, WindType,   WindPadFact, ...
                Opt{5}, 0);
            otherwise
        end
    %========================================
    otherwise
    %========================================
end