function [iter] = Buss_3_GA( FileNam, FileSav, iter, ...
    LSQ, FMINsear, GA, ...
    Q_RespMTONE, fQMIX, fxQMIX, fxVEC, InputSymCEL, ...
    Qmix, Q_cell)
Opt = iter.Opt;

NumParam = length(Opt.xReal_0);
switch Opt.Optim_Meth
    %=================================
    case{'lsqnonlin','fminsearch'}
        [LSQ.MaxIter            NumParam]
        [FMINsear.MaxIter     	NumParam]
        FileSav_LSQ = FileSav;
        save('FileNam_LSQ.mat', 'FileSav_LSQ')% filename var
    %=================================
    case{'ga'}
        [GA.pop     GA.gen     	NumParam]
        FileSav_GA = FileSav;
        save('FileNam_GA.mat', 'FileSav_GA')% filename var
    %=================================
end

if( exist(FileSav, 'file') )
	%---------------------------------
	whos('-file', FileSav);
	FileOpt	= input([FileNam ' exist [0:del |1:keep ]: '], 's');% |2:diff-file
	switch FileOpt
     	%----------------
        case{'0'}
            delete(FileSav);
            FileCreat   = 1;
     	%----------------
    	%case{'2'}
        % 	FileCreat	= 1;
        %  	FileNam     = input(['FileNam ' Opt.Optim_Meth ': '], 's');
        %  	FileSav     = fullfile(PATH.MatlabSave, [FileNam '.mat'])
     	%----------------
        otherwise% case{'1'}
            FileCreat   = 0;
     	%----------------
	end
else%---------------------------------
	FileCreat = 1;
	%---------------------------------
end
if FileCreat
    switch Opt.Optim_Meth
        case{'lsqnonlin'}
            save(FileSav_LSQ, 'LSQ');
        case{'fminsearch'}
            save(FileSav_LSQ, 'FMINsear');
        case{'ga'}
            save(FileSav_GA, 'GA');
    end
end

pause
%% ==================================================== ITER1 
switch Opt.Optim_Meth
    %====================================================
    case{'lsqnonlin'}
        LSQ.Optim_Options	= optimset(Opt.Optim_Meth);
        LSQ.MaxFunEvals     = 400 * NumParam;
        LSQ.Optim_Options 	= optimset(LSQ.Optim_Options, 'PrecondBandWidth',LSQ.PrecondBandWidth, ...
         	'MaxIter',LSQ.MaxIter, ...% 'MaxIter',400, 
            'OutputFcn',{@Plot_LSQ_Func2}, ...
            'TolFun',LSQ.TolFun,'MaxFunEvals',LSQ.MaxFunEvals);% 'TolFun',0.1, 'MaxFunEvals',100*
        % {'Display','final', 'notify' 'iter' 'final'}
        % 'TolX',1e-4,
RunTime_LSQ = tic;
[x, resnorm, residual, exitflag, output] = lsqnonlin( @(x) ...
  	Buss_XR4_Iter( x, Opt, ...
            Q_RespMTONE, fQMIX, fxQMIX, fxVEC, InputSymCEL, ...
            Qmix, Q_cell), ...
 	Opt.xReal_0, [],[],LSQ.Optim_Options);
RunTime_LSQ = toc(RunTime_LSQ)
        %----------------------
        iter.xReal_0	= Opt.xReal_0;
       	iter.xReal    	= x;
      	iter.residual	= residual;
      	iter.output   	= output;
        iter.RunTime    = RunTime_LSQ;
            iter.Pop_LSQ	= load(FileSav_LSQ, 'Pop_LSQ');
            iter.Pop_LSQ	= iter.Pop_LSQ.Pop_LSQ;
    %====================================================
    case{'fminsearch'}% 'OutputFcn' problematic: don't like 'FunValCheck','on'
        %NOT PREFERRED for solving sums-of-squares problems  => lsqnonlin 
        %only minimizes over the real numbers, f(x) must only return real numbers
        %COMPLEX VARIABLES must be split into R+jI
    	%robust for discontin problem, less efficient than fminunc order > 2
        FMINsear.Optim_Options	= optimset(Opt.Optim_Meth);
        FMINsear.MaxFunEvals   	= 400 * NumParam;
        FMINsear.MaxIter        = FMINsear.MaxIter * NumParam / 4;
        FMINsear.Optim_Options 	= optimset(FMINsear.Optim_Options, ...
         	'MaxIter',FMINsear.MaxIter, ...
            'OutputFcn',@Plot_LSQ_Func2, ...%
            'TolFun',FMINsear.TolFun,'MaxFunEvals',FMINsear.MaxFunEvals);
        % fminsearch=[1e-4 1e-4]
        % {'Display','final', 'notify' 'iter' 'final'}
        % 'FunValCheck','on', 
        % 'TolX',1e-4,
RunTime_LSQ = tic;
[x, fval, exitflag, output] = fminsearch( @(x) ...
    Buss_XR4_Iter( x, Opt, ...
            Q_RespMTONE, fQMIX, fxQMIX, fxVEC, InputSymCEL, ...
            Qmix, Q_cell), ...
 	Opt.xReal_0, FMINsear.Optim_Options);
RunTime_LSQ = toc(RunTime_LSQ)
        %----------------------
        iter.xReal_0	= Opt.xReal_0;
       	iter.xReal    	= x;% x of next to Last iter
      	iter.output   	= output;
        iter.RunTime    = RunTime_LSQ;
            iter.Pop_LSQ	= load(FileSav_LSQ, 'Pop_LSQ');
            iter.Pop_LSQ	= iter.Pop_LSQ.Pop_LSQ;
    %====================================================
    case{'fminunc'}
        %NOT PREFERRED for solving sums-of-squares problems  => lsqnonlin 
        %LargeScale:  must provide the gradient
        %Medium-scale: Quasi-Newton line search (Algorithm selected)
     	%Warning: Gradient must be provided for trust-region method =>  using line-search method instead.
        %Optimization terminated: relative infinity-norm of gradient less than options.TolFun.
RunTime_LSQ = tic;
[x, fval, exitflag, output] = fminunc( @(x) ...
  	Buss_XR4_Iter( x, Opt, ...
            Q_RespMTONE, fQMIX, fxQMIX, fxVEC, InputSymCEL, ...
            Qmix, Q_cell), ...
 	Opt.xReal_0, FMINunc.Optim_Options);
        % fminunc=[1e-6 1e-6]
        % 'PrecondBandWidth',LSQ.PrecondBandWidth, ...
        % {'Display','final', 'notify' 'iter' 'final'}
        % 'FunValCheck','on', 'Diagnostics','on'
        % 'TolX',1e-4,
RunTime_LSQ = toc(RunTime_LSQ)
        %----------------------
    %====================================================
    case{'ga'}
        GA.Optim_Options	= gaoptimset;
        GA.Optim_Options 	= gaoptimset(GA.Optim_Options, ...
          	'PopulationSize',GA.pop, 'Generations',GA.gen,...% 'InitialPopulation',final_pop,
            'PlotFcns',{@Plot_GA_Func}, 'PlotInterval',1,...% @gaplotbestf @gaplotbestindiv @gaplotdistance
            'FitnessLimit',GA.FitnessLimit, 'TimeLimit',GA.TimeLimit,...%500 default=-inf
            'TolFun',GA.TolFun, 'StallTimeLimit',GA.TimeLimit, 'StallGenLimit',GA.StallGenLimit)
            % 'FitnessLimit' = (RelErr 0.1 ~ -10dB) * Wt * #pts
            % 'Display','iter' , ...
            % 'PopInitRange', [x2INTERMED-(1+j); x2INTERMED+(1+j)], [Opt.xReal_0-(1+j); Opt.xReal_0+(1+j)]
            % 'HybridFcn',{@fminunc}, @fminsearch
            % MigrationDirection
%output.XXX
%randstate       rand  state before the algorithm started. 
%randnstate      randn state (randstate + randnstate to reproduce)
%generations     # generations computed.
%funccount       # evaluations of fitness function
%message         same as output argument reason (why algorithm terminated)
%maxconstraint   Maximum constraint violation, if any
    %rand('state',  output.randstate);
    %randn('state', output.randnstate);
RunTime_GA = tic;
[x, F2, reason, output, final_pop, final_score] = ga(@(x) ...
  	Buss_XR4_Iter( x, Opt, ...
            Q_RespMTONE, fQMIX, fxQMIX, fxVEC, InputSymCEL, ...
            Qmix, Q_cell), ...
	NumParam, [],[],[],[],[],[],[],GA.Optim_Options);
RunTime_GA = toc(RunTime_GA)
        %----------------------
        iter.xReal      = x.';% GA pass ROWvec
        iter.output   	= output;
        iter.final_score = final_score;
        iter.RunTime    = RunTime_GA;
            iter.Pop_GA     = load(FileSav_GA, 'Pop_GA');
            iter.Pop_GA     = iter.Pop_GA.Pop_GA;
    %====================================================
end

%%
%[Opt.xReal_0 x2Param x2Param_0.' x2INTERMED]
%x2INTERMED  	= [ x2a(1:N-1);     x2ZHD(1:(NumHD+1))	    ];	Opt_ITER = {2 'x2BBZF' x2ZBB_0 x2Zf_0};

%compute response
%    [F2 Q_RespMTONE] = ...
%Buss_XR4_Iter(Opt.Optim_Meth, x, ...
%    Q_RespMTONE, Opt_ITER, Opt_WtS21Err, ...
%    InputSymCEL, ...
%    fQMIX, fxQMIX, fxVEC, ...
%    Qmix, Q_cell, 0);
