function state = Plot_GA_Func( options, state, flag)
%state
%whos state
%Population  Population in the current generation
%Score       Scores of the current population
%Generation  Current generation number
%StartTime   Time when genetic algorithm started 
%StopFlag    String containing the reason for stopping
%Selection   Indices of individuals selected for elite, crossover and mutation
%Expectation  Expectation for selection of individuals
%Best        Vector containing the best score in each generation
%LastImprovement         Generation at which the last improvement in fitness value occurred
%LastImprovementTime     Time at which last improvement occurred
%NonlinIneq  Nonlinear inequality constraints, displayed only when a nonlinear constraint function is specified
%NonlinEq    Nonlinear equality constraints, displayed only when a nonlinear constraint function is specified

load('FileNam_GA.mat', 'FileSav_GA')% FileSav_GA = filename var
    %whos('-file', FileSav_GA);
    %disp('inside Plot_GA_Func')
    %pause
Gen = state.Generation
[ScoreSort, ScoreSortIDX_0] = sort(state.Score, 'ascend');
switch Gen
    %----------------------
    case{0}
        Pop_GA.StateSave_0	= state;
        %ScoreSortIDX_0
        Pop_GA.t_0         	= tic;
        Pop_GA.StateSave   	= struct;
        Pop_GA.ScoreSortIDX	= [];
        Pop_GA.t           	= [];
        save(FileSav_GA, 'Pop_GA', '-append');% save(FileSav_GA, 'StateSave_0','ScoreSortIDX_0','t_0', ...
        %                 'StateSave','ScoreSortIDX','t', '-append');
    %----------------------
    case{1}
      	load(FileSav_GA, 'Pop_GA');% load(FileSav_GA, 'StateSave','ScoreSortIDX','t', 't_0');
        Pop_GA.StateSave            = state;
        Pop_GA.ScoreSortIDX(Gen,:)  = ScoreSortIDX_0;
        Pop_GA.t(Gen)               = toc(Pop_GA.t_0);
        save(FileSav_GA, 'Pop_GA', '-append');%save(FileSav_GA, 'StateSave','ScoreSortIDX','t', '-append');
    %----------------------
    otherwise
      	load(FileSav_GA, 'Pop_GA');% load(FileSav_GA, 'StateSave','ScoreSortIDX','t', 't_0');% can't StateSave = load()
        Pop_GA.StateSave(Gen)      = state;
        Pop_GA.ScoreSortIDX(Gen,:) = ScoreSortIDX_0;
        Pop_GA.t(Gen)              = toc(Pop_GA.t_0);
        save(FileSav_GA, 'Pop_GA', '-append');%save(FileSav_GA, 'StateSave','ScoreSortIDX','t', '-append');
    %----------------------
end
    for nscore = 1 : 5
        figure(200)
            plot(Gen,    	ScoreSort(nscore),              	'-bo'); grid on; hold on;
        figure(201)
            semilogy(Gen, 	ScoreSort(nscore),              	'-bo'); grid on; hold on;
            %semilogy(Gen,  state.Score(ScoreSortIDX_0(nscore)),'-bo'); grid on; hold on;
    end

%% TEST
if(0)
%------------------------------------------------

        %BestScore = state.Best;
        %if(length(BestScore) > 1)
        %    BestScore = min( BestScore );
        %    [Gen BestScore]
        %end
        %if( ScoreSort(1) ~= BestScore )
        %    pause
        %end

%------------------------------------------------
end