function [Err FunEval Err_All FunEval_All] = Plot_GA_PopErr( GA, ...
    FileNam_GA, Path, ...
    NumGen, NumBestSoln, ...
    FigVEC, LineSpec, PlotOpt, Opt_Fig)

FileSav_GA      = fullfile(Path, [FileNam_GA '.mat'])
    whos('-file', FileSav_GA);
    load(FileSav_GA, 'StateSave_0','ScoreSortIDX_0','t_0', ...
               	'StateSave','ScoreSortIDX','t')%, ... 'RunTime_GA'
    if ~exist('ScoreSortIDX','var')
        for Gen = 1 : length(StateSave)
            [ScoreSort, ScoreSortIDX_0] = sort(StateSave(Gen).Score, 'ascend');
            ScoreSortIDX(Gen,:) = ScoreSortIDX_0;
        end
        save(FileSav_GA, 'ScoreSortIDX', '-append');
    end
    
if ~exist('NumGen','var')
    NumGen 	= length(StateSave);
end
[NumBestSoln_ NumParam]	= size(StateSave(1).Population);
    if isempty(NumBestSoln)
        NumBestSoln = NumBestSoln_;
    end

for Gen = 1 : length(StateSave)
	popIDX	= ScoreSortIDX(Gen,1);
    %----------------------
    Err_All(:,Gen)      = StateSave(Gen).Score( popIDX );
    FunEval_All(Gen)    = StateSave(Gen).FunEval;
	%----------------------
end
    
[NumBestSoln_	NumBestSoln     NumGen      NumParam]
%% ###############
Err     = zeros(NumBestSoln,    NumGen);% plot matrix COL
FunEval = zeros(1,              NumGen);
    %FunEval = zeros(NumBestSoln, NumGen);% plot matrix COL
Time	= zeros(1,              NumGen);
    Time = Reshape_Func(t, Time);
    %Time = repmat(t, [NumBestSoln 1]);% t = [1,NumGen]
x       = {[]};
for Gen = 1 : NumGen
    %Gen    = StateSave(Gen).Generation
	popIDX	= ScoreSortIDX(Gen,1:NumBestSoln);
    %----------------------
    Err(:,Gen)      = StateSave(Gen).Score( popIDX );
    FunEval(Gen)    = StateSave(Gen).FunEval;
    %FunEval(:,Gen) = repmat(StateSave(Gen).FunEval, [NumBestSoln 1]);
    %----------------------
    pop = StateSave(Gen).Population( popIDX, :);
    for nparam = 1 : NumParam% size(pop, 2)
        x{nparam}(:,Gen) = pop(:,nparam);
    end
	%----------------------
end

%% Reshape ############### Err(Gen) FunEval(Gen) Err(FunEval)
xAXIS_	= (1:prod(size(Err))) / NumBestSoln;% (1 : NumBestSoln*NumGen)
Err_   	= reshape(  Err                                 ,1,[]);
FunEval_ = reshape( repmat(FunEval, [NumBestSoln 1])	,1,[]);
Time_	= reshape(  repmat(Time,    [NumBestSoln 1])	,1,[]);
x_      = {[]};
    for nparam = 1 :  NumParam/2% length(x)/2
        x_{nparam} = reshape( x{nparam}+j*x{nparam+NumParam/2} ,1,[]);
    end

if ~isempty(FigVEC)
switch 'Err/FuncEval (Gen)'
	%------------------------------------------------
    case{'Err/FuncEval (Gen)'}
 	%if(0)% Err(Gen) FunEval(Gen) 
    %   plot_Sio_Func( xAXIS_, Err_ + j*FunEval_, ...
    %        'RI', 'yLogABS', ...
    %        FigVEC(1), 'Xlin', LineSpec, ...
    %        [], ['GA'], {'Generation'}, {'Error' 'Number of Funnction Evaluation'}, ['GA w/Pop=' num2str(GA.pop)]);%FileNam_GA
    %else
        plot_Sio_Func2( xAXIS_, Err_ + j*FunEval_, FigVEC(1), ...
            'RI',{'yLogABS'},{'xLin'},{}, ...
            {'GA'},{'Generation'},{'Error' 'Number of Function Evaluation'},{['GA w/Pop=' num2str(GA.pop)]}, ...
            ['-.' LineSpec(2:end)], PlotOpt, Opt_Fig);
	%end
	%------------------------------------------------
    case{'Niche'}% Niche
    for nparam = 1 : length(x)/2
        plot_Sio_Func( xAXIS_, x_{nparam}, ...
            'RI', 'RI-Lin', ...
            FigVEC(2)+nparam, 'Xlin', LineSpec, ...
            [], ['GA x' num2str(nparam)], {'Gen'}, {}, [FileNam_GA]);
    end
	%------------------------------------------------
%    case{'mesh'}
%    plot_Sio_Mesh((1:NumGen), (1:NumBestSoln), Lin2dB(Err), 'dB', 'meshc', ...
%            FigVEC(1), {[] []}, {[] [] []}, ...
%            [], ['GA'], {'Gen' 'NumBestSoln'}, [FileNam_GA]);
%for nparam = 1 : length(x)
%    plot_Sio_Mesh((1:NumGen), (1:NumBestSoln), x{nparam}, 'RI', 'meshc', ...
%            FigVEC(2)+nparam, {[] []}, {[] [] []}, ...
%            [], ['GA x' num2str(nparam)] , {'Gen' 'NumBestSoln'}, [FileNam_GA]);
%end
	%------------------------------------------------
end
end
