function [ ] = Plot_Spectr_LSNA( Wav, WavIN, ...
    Opt, Meas, fmix_PART, ...
    PlotOpt, LegWavnam, Opt_Fig, FigOffset)

fnumMAT_PARTIDX = Opt.Idx_Seq{ 1 };
P2_IDX          = Opt.Idx_Seq{ 2 };
DF_IDX          = Opt.Idx_Seq{ 3 };
P1_IDX          = Opt.Idx_Seq{ 4 };
%% ################################################## 
    nMARK	= 0;
for nP1 = P1_IDX
for nDF = DF_IDX
%=====================================================================================
    nMARK	= nMARK + 1;
    switch Opt.MeasType
        case{'2Tone'}% nDF dependent
            x_dBmVEC	= real( Lin2dB( WavIN.a1_f1{nDF} ) + ...
                                Lin2dB( WavIN.a1_f2{nDF} ) )/2;
        case{'2Tone_Cosite'}% nP1 dependent
            %x_dBmVEC	= real( Lin2dB( WavIN.A_f1{nDF,nP1} ) );
            x_dBmVEC	= real( Lin2dB( WavIN.B_f2{nDF,nP1} ) );
    end
    for nWAV = 1 : length( Opt.WavName )
        WavName             = Opt.WavName{ nWAV };
		z_WavMAT.(WavName)	= NaN * ones([length(P2_IDX)	size(fnumMAT_PARTIDX, 2)]);% [P2  nMIX]
    end
%--------------------------------------------------------------------------------------
for nMIX = 1 : size( fnumMAT_PARTIDX, 2)
    nIM	= fnumMAT_PARTIDX( nDF, nMIX );
if ~isnan(nIM)
    fIM	= Meas.SigGen0_Mhz{ nDF }( nIM );
        y_fVEC_P2           = fIM * ones([1  length(P2_IDX)]);
        y_fMAT(nDF, nMIX)	= fIM;
    for nWAV = 1 : length( Opt.WavName )
        WavName                     = Opt.WavName{ nWAV };
		z_WavMAT.(WavName)(:,nMIX)	= Wav.(WavName){nDF,nP1}(nIM,:);% [P2  nMIX]
    end
switch Opt.PlotType
%=====================================================================================
	case{'2Dspectra_xIdx','2Dspectra_xLin','2Dspectra_xLog'}
	x_fVEC  = y_fVEC_P2;
    xLab=['Frequency(' Meas.FreqUnit ')']; Line='';
	switch Opt.PlotType
        case{'2Dspectra_xIdx'}
            xScale	= 'xLin';
            x_fVEC	= 1 : length( x_fVEC ); xLab='Index';% x_fVEC(find(x_fVEC == NaN)) = NaN;
        case{'2Dspectra_xLin'}
            xScale	= 'xLin'; 
        case{'2Dspectra_xLog'}
            xScale  = 'xLog';
    end
for nWAV = 1 : length( Opt.WavName )
	WavName	= Opt.WavName{ nWAV };
     	BoolPlot	= 0;    BoolMix = 0;
        TitleSTR    = [Meas.DUT_name ' (' LegWavnam ')'];
      	LegSTR=[];
       	switch Opt.MeasType
         	%------------------------------------------
          	case{'2Tone'}
                switch WavName
                    case{'a1'}
                        if isequal( fmix_PART(nMIX,:), [1 0])
                            BoolPlot=1;		Color='g'; Mark='d'; BoolMix=1; 
                        elseif isequal( fmix_PART(nMIX,:), [0 1])
                            BoolPlot=1;		Color='g'; Mark='d'; BoolMix=1; 
                        end
                    case{'b2','b1','a2'}
                      	BoolPlot = 1; 
                        switch WavName
                            case{'b2'}
                                Color='k'; Mark='*';
                            case{'b1'}
                                Color='r'; Mark='o';
                            case{'a2'}
                                Color='b'; Mark='+';
                        end
                        if(nMIX == 1) BoolMix=1; end
                end
              	if((BoolPlot == 1) && (nMARK == 1) && BoolMix)
                	LegSTR = [WavName ' DF=' num2str(Meas.DF_KHz(nDF)) 'kHz'];
              	end
         	%------------------------------------------
           	case{'2Tone_Cosite'}
                Color	= PlotOpt.colors(nMARK);
                switch WavName
                    case{'A'}
                        if isequal( fmix_PART(nMIX,:), [1 0])
                            BoolPlot=1;		Mark='d'; BoolMix=1; 
                        end
                    case{'B'}
                        if isequal( fmix_PART(nMIX,:), [0 1])
                            BoolPlot=1;		Mark='d'; BoolMix=1; 
                        end
                    case{'C'}
                      	BoolPlot = 1;       Mark=PlotOpt.marker(nMARK); 
                        if(nMIX == 1) BoolMix=1; end
                end
              	if((BoolPlot == 1) && (nMARK == 1) && (BoolMix))
                    switch WavName
                        case{'A','B'}
                            LegSTR = [WavName ' P1=' num2str(Meas.SigGen1_dBm(nP1)) 'dBm'];
                        case{'C'}
                            if(nMIX==1)
                                LegSTR = [WavName ' P1=' num2str(Meas.SigGen1_dBm(nP1)) 'dBm'];
                            end
                    end
              	end
         	%------------------------------------------
        end
    	if(BoolPlot)
            plot_Sio_Func2( x_fVEC, Lin2dB_dB( z_WavMAT.(WavName)(:,nMIX) ), [1 + FigOffset], ...
                'dB',{'yLin'},{xScale},{}, ...
                {TitleSTR},{xLab},{'dBm' 'Deg'},{LegSTR}, ...
                [Line Color Mark], Opt_Fig);
        end
end
%=====================================================================================
	case{'3Dspectra'}
for nWAV = 1 : length( Opt.WavName )
 	WavName	= Opt.WavName{ nWAV };
     	BoolPlot	= 0;    BoolMix = 0;
        TitleSTR	= [Meas.DUT_name ' (' LegWavnam ')'];
        xLab=['P2(' Meas.AmpUnit ')']; yLab=['Frequency(' Meas.FreqUnit ')']; LegSTR=[];
       	switch Opt.MeasType
         	%------------------------------------------
          	case{'2Tone'}
                switch WavName
                    case{'a1'}
                        if isequal( fmix_PART(nMIX,:), [1 0])
                            BoolPlot=1;	Line=':';       Color='g'; Mark='.'; BoolMix=1; 
                        elseif isequal( fmix_PART(nMIX,:), [0 1])
                            BoolPlot=1;	Line='-.';      Color='g'; Mark='.'; BoolMix=1; 
                        end
                    case{'b2','b1','a2'}
                      	BoolPlot = 1; Line='-';   
                        switch WavName
                            case{'b2'}
                                Color='k'; Mark='*';
                            case{'b1'}
                                Color='r'; Mark='o';
                            case{'a2'}
                                Color='b'; Mark='+';
                        end
                        if(nMIX == 1) BoolMix=1; end
                end
              	if((BoolPlot == 1) && (nMARK == 1) && BoolMix)
                	LegSTR = [WavName ' DF=' num2str(Meas.DF_KHz(nDF)) 'kHz'];
              	end
         	%------------------------------------------
           	case{'2Tone_Cosite'}
                Color	= PlotOpt.colors(nMARK);
                switch WavName
                    case{'A'}
                        if isequal( fmix_PART(nMIX,:), [1 0])
                            BoolPlot=1;	Line=':'; Mark=''; BoolMix=1; 
                        end
                    case{'B'}
                        if isequal( fmix_PART(nMIX,:), [0 1])
                            BoolPlot=1;	Line='-.'; Mark=''; BoolMix=1; 
                        end
                    case{'C'}
                      	BoolPlot = 1; Line='-'; Mark=PlotOpt.marker(nMARK); 
                        if(nMIX == 1) BoolMix=1; end
                end
              	if((BoolPlot == 1) && (nMARK == 1) && (BoolMix))
                    switch WavName
                        case{'A','B'}
                            LegSTR = [WavName ' P1=' num2str(Meas.SigGen1_dBm(nP1)) 'dBm'];
                        case{'C'}
                            if(nMIX==1)
                                LegSTR = [WavName ' P1=' num2str(Meas.SigGen1_dBm(nP1)) 'dBm'];
                            end
                    end
              	end
         	%------------------------------------------
        end
    	if(BoolPlot)
          	plot_Sio_Mesh( x_dBmVEC, y_fVEC_P2, Lin2dB_dB( z_WavMAT.(WavName)(:,nMIX) ), [1 + FigOffset], ...
              	'dB', [], ...
               	TitleSTR, {xLab  yLab 'dBm' 'deg'}, LegSTR, ...
              	[Line Color Mark], Opt_Fig, struct('Type','plot3'));
     	end
end
%=====================================================================================
end
end
end
%--------------------------------------------------------------------------------------
switch Opt.PlotType
%###################################################################################
	case{'2Dspectra_xIdx_MAT','2Dspectra_xLin_MAT','2Dspectra_xLog_MAT'}
% nDF: same[-diff] plot
% ab#:       diff  plot
	x_fVEC  = y_fMAT(nDF, :);% out of order due to MIX.fnumMAT_ALL, need sort
    xLab=['Frequency(' Meas.FreqUnit ')']; Line='';
	switch Opt.PlotType
        case{'2Dspectra_xIdx'}
            xScale	= 'xLin';
            x_fVEC	= 1 : length( x_fVEC ); xLab='Index';% x_fVEC(find(x_fVEC == NaN)) = NaN;
        case{'2Dspectra_xLin'}
            xScale	= 'xLin'; 
        case{'2Dspectra_xLog'}
            xScale  = 'xLog';
    end
for nP2 = P2_IDX
for nWAV = 1 : length( Opt.WavName )
	WavName	= Opt.WavName{ nWAV };
        TitleSTR    = [Meas.DUT_name ' (' LegWavnam ')'];
      	LegSTR=[];
       	switch Opt.MeasType
         	%------------------------------------------
          	case{'2Tone'}
                switch WavName
                    case{'b2'}
                      Color='k'; Mark='*';
                  	case{'b1'}
                      Color='r'; Mark='o';
                   	case{'a2'}
                      Color='b'; Mark='+';
              	end
              	if((nP2 == 1) && (nMARK == 1))
                	LegSTR = [WavName ' DF=' num2str(Meas.DF_KHz(nDF)) 'kHz'];
              	end
         	%------------------------------------------
           	case{'2Tone_Cosite'}
                Color	= PlotOpt.colors(nMARK);
                switch WavName
                    case{'C'}
                      	Mark=PlotOpt.marker(nMARK); 
                end
              	if((nP2 == 1) && (nMARK == 1))
                 	LegSTR = [WavName ' P1=' num2str(Meas.SigGen1_dBm(nP1)) 'dBm'];
              	end
         	%------------------------------------------
        end
        plot_Sio_Func2( x_fVEC, Lin2dB_dB( z_WavMAT.(WavName)(nP2,:) ), [1 + FigOffset], ...
            'dB',{'yLin'},{xScale},{}, ...
            {TitleSTR},{xLab},{'dBm' 'Deg'},{LegSTR}, ...
            [Line Color Mark], Opt_Fig);
end
end
%###################################################################################
	case{'3Dspectra_MAT'}
for nWAV = 1 : length( Opt.WavName )
	WavName = Opt.WavName{ nWAV };
        TitleSTR    = [Meas.DUT_name ' (' LegWavnam ')'];
     	xLab=['P2(' Meas.AmpUnit ')']; yLab=['Frequency(' Meas.FreqUnit ')']; LegSTR=[WavName ];
       	switch Opt.MeasType
         	%------------------------------------------
          	case{'2Tone'}
                switch WavName
                  	case{'b2'}
                      	Line='-'; Color='k'; Mark='*';
                   	case{'b1'}
                       	Line='-'; Color='r'; Mark='o';
                  	case{'a2'}
                      	Line='-'; Color='b'; Mark='+';
                end
         	%------------------------------------------
           	case{'2Tone_Cosite'}
                Color   = PlotOpt.colors(nMARK);
                switch WavName
                    case{'A'}
                     	Line=':'; Mark=''; 
                    case{'B'}
                      	Line='-.'; Mark=''; 
                    case{'C'}
                        Line='-'; Mark=PlotOpt.marker(nMARK); 
                end
         	%------------------------------------------
        end
        [X,Y] = meshgrid( y_fMAT(nDF,:), x_dBmVEC);%size( X ); size( Y ; size( Lin2dB_dB( z_WavMAT.(WavName), 'COL') )
     	plot_Sio_Mesh( X, Y, Lin2dB_dB( z_WavMAT.(WavName), 'COL'), [1 + FigOffset], ...
          	'dB', [], ...
           	TitleSTR, {yLab  xLab  'dBm' 'deg'}, LegSTR, ...
          	[Line Color Mark], Opt_Fig, struct('Type','plot3'));
end
%###################################################################################
end
%=====================================================================================
end
end
