function [] ...
    = Plot_ToneFile_Func(Gain,Plot_Flag,Plot_Title, ...
    fig_Gain,colors, ...
    File_Start,File_Stop,NumSeg_Start,NumSeg_Stop)

figure(fig_Gain);
subplot(2,1,1); hold on;
    title(cat(2,'|',Plot_Title,'|'));
    ylabel('Amplitude [dBU]');
    xlabel('File Index');
subplot(2,1,2); hold on;
    title(cat(2,'Pha(',Plot_Title,')'));
    ylabel('Phase [Degree]');
    xlabel('File Index');

%% 
for k = NumSeg_Start : NumSeg_Stop
    subplot(2,1,1);
    switch Plot_Flag{1}
        case 'Index_f1f2_IM3'
            plot( (Gain(File_Start:File_Stop,(2+4*(k-1)))), cat(2,colors(k),'-o') );
            plot( (Gain(File_Start:File_Stop,(3+4*(k-1)))), cat(2,colors(k),'-d') );
        case 'f1f2'
            plot( Lin2dB(Gain(File_Start:File_Stop,(2+4*(k-1)))), cat(2,colors(k),'-o') );
            plot( Lin2dB(Gain(File_Start:File_Stop,(3+4*(k-1)))), cat(2,colors(k),'-d') );
        case 'IM3'
            plot( Lin2dB(Gain(File_Start:File_Stop,(1+4*(k-1)))), cat(2,colors(k),'-o') );
            plot( Lin2dB(Gain(File_Start:File_Stop,(4+4*(k-1)))), cat(2,colors(k),'-d') );
    end

    subplot(2,1,2);
    switch Plot_Flag{1}
        case 'Index_f1f2_IM3'
            plot( (Gain(File_Start:File_Stop,(1+4*(k-1)))), cat(2,colors(k),'-o') );
            plot( (Gain(File_Start:File_Stop,(4+4*(k-1)))), cat(2,colors(k),'-d') );
        case 'f1f2'
            plot( angle(Gain(File_Start:File_Stop,(2+4*(k-1))))/pi*180, cat(2,colors(k),'-o') );
            plot( angle(Gain(File_Start:File_Stop,(3+4*(k-1))))/pi*180, cat(2,colors(k),'-d') );
        case 'IM3'
            plot( angle(Gain(File_Start:File_Stop,(1+4*(k-1))))/pi*180, cat(2,colors(k),'-o') );
            plot( angle(Gain(File_Start:File_Stop,(4+4*(k-1))))/pi*180, cat(2,colors(k),'-d') );
    end
end

subplot(2,1,1); grid on;
    switch Plot_Flag{1}
        case 'Index_f1f2_IM3'
            legend('Index_f1', 'Index_f2', 'Location', 'Best');
        case 'f1f2'
            legend('f1', 'f2', 'Location', 'Best');
        case 'IM3'
            legend('im3l', 'im3h', 'Location', 'Best');
    end
subplot(2,1,2); grid on;
    switch Plot_Flag{1}
        case 'Index_f1f2_IM3'
            legend('Index_im3l', 'Index_im3h', 'Location', 'Best');
        case 'f1f2'
            legend('f1', 'f2', 'Location', 'Best');
        case 'IM3'
            legend('im3l', 'im3h', 'Location', 'Best');
    end

