function [] = plot_Sio_Mesh(x, y, z, fig, ...
            dBMaRi, AxisVEC, ...
            titleSTR, xyLabelCEL, LegSTR, ...
            LineSpec, Opt_Fig, Opt, ...
            PlotOpt)
%plot_Sio_Mesh(x, y, z, dBMaRi, Opt_Plot, ...
%            fig, Opt_Face, Opt_Line, ...
%            AxisVEC, titleSTR, xyLabelCEL, LegSTR)
if ~exist('PlotOpt','var')
    %PlotOpt = struct('Ln_Width',1,'Mkr_Size',6,'Font_Name','Times', 'Font_Size',10,'Font_Size_Leg',10,'Font_Weight','normal');
    %PlotOpt = struct('Ln_Width',2,'Mkr_Size',14,'Font_Name','Times', 'Font_Size',30,'Font_Size_Leg',24,'Font_Weight','normal');
    %PlotOpt = struct('Ln_Width',2,'Mkr_Size',8,'Font_Name','Times', 'Font_Size',12,'Font_Size_Leg',12,'Font_Weight','normal');
    PlotOpt = struct('Ln_Width',2,'Mkr_Size',6,'Font_Name','Times', 'Font_Size',24,'Font_Size_Leg',24,'Font_Weight','normal');
elseif isempty( PlotOpt )
    %PlotOpt = struct('Ln_Width',2,'Mkr_Size',14,'Font_Name','Times', 'Font_Size',30,'Font_Size_Leg',24,'Font_Weight','normal');
    PlotOpt = struct('Ln_Width',2,'Mkr_Size',8,'Font_Name','Times', 'Font_Size',12,'Font_Size_Leg',12,'Font_Weight','normal');
end
%--------------------------------------------------
if ~exist('Opt_Fig','var')
    Opt_Fig         = '2-Fig';
end
switch Opt_Fig
    case{'2-Fig'}
        nPLOT_end	= 2;
    otherwise% case{'1-Fig','0-Fig'}
        nPLOT_end	= 1;
end
%--------------------------------------------------
switch Opt.Type
    %=================================
    case{'plot3'}
    %=================================
    case{'mesh','meshc'}
        %{'FaceColor'       'FaceAlpha'}
        % [1 1 1] [0 0 0] 
        if ~isfield(Opt,'Face')
            Opt.Face	= {[1 1 1]  1};
        end
        %{'EdgeColor'       'EdgeAlpha'     'LineWidth'}
        %none flat interp  	1               0.5 Ln_Width
        if ~isfield(Opt,'Line')
            Opt.Line	= {'flat' 1  0.5};
        end
    %=================================
end

% x: ROW/COL
% y: ROW/COL
% z: ROW/COL dim=1
%    MAT     dim=2 (plot each COL vs x)
%-------------------------
% IM spectral
% 1) plot3:	each line = IM across swept power
%% ##############################################
switch dBMaRi
	case {'VV'}
      	zLabelCEL = {'(V)' '(Deg)'};
    case {'RI'}
        zLabelCEL = {'Re' 'Im'};
    case {'dB'}
        zLabelCEL = {'dB' 'Deg'};
    case {'MA'}
        zLabelCEL = {'Mag' 'Deg'};
    otherwise
        zLabelCEL = {[] []};
end

%% ##############################################
for nFIG = 1 : nPLOT_end
%%##############################################
    switch nFIG
        case{1}
            figure( fig );
            Z = real(z);
        case{2}
            figure( fig + 1e6 );
            Z = imag(z);
    end
%%##############################################
switch Opt.Type
%==============================================================
    case{'plot3'}
        plot3( x,y,Z, LineSpec,'LineWidth',PlotOpt.Ln_Width,'MarkerSize',PlotOpt.Mkr_Size); grid on; hold on;
%==============================================================
    case{'mesh','meshc'}
        switch Opt.Type
            case {'mesh'} %Lin Plots of RI parts
                h = mesh( x,y,Z);
            case {'meshc'} %AbsLog Plots of RI parts
                h = meshc( x,y,Z);
        end
    set(h, 'FaceColor',Opt.Face{1},'FaceAlpha',Opt.Face{2}); grid on; hold on; 
    set(h, 'EdgeColor',Opt.Line{1},'EdgeAlpha',Opt.Line{2},'LineWidth',Opt.Line{3});
%==============================================================
end
%%##############################################
    if ~isempty( AxisVEC )
        if (size(AxisVEC,2) ~= 0)
            if(nFIG <= size(AxisVEC,1))
                nAXIS = nFIG;
            else
                nAXIS = 1;
            end
            axis( AxisVEC(nAXIS,:) );
        end
    end
%%##############################################
    set(gca, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
    if ~isempty(xyLabelCEL)
        xlabel(xyLabelCEL{1}, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
        ylabel(xyLabelCEL{2}, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
    end
    %-------------------------
    if (length(xyLabelCEL) >= 3)
        zlabel(xyLabelCEL{2+nFIG}, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
    else
        zlabel(zLabelCEL{nFIG}, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight);
    end
    %-------------------------
    if ~isempty(titleSTR)
        title(titleSTR, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight);
    end
    %-------------------------
    if ~isempty(LegSTR)
        [leg_h, obj_h, plot_h, TextSTR] = legend(gca);
        TextSTR{ end+1 } = LegSTR;
        legend(gca, TextSTR, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size_Leg,'FontWeight',PlotOpt.Font_Weight);
    end
%%##############################################
end

%% TEST
if (0)

%++++++++++++++++++++ f1f2
figure(fig_Mesh1)
h = mesh( adBm_Avg, fDSB_LSNA_dB, adBm_DSB_LSNA );      set(h, 'FaceColor',[0 0 0],'FaceAlpha',0.3); grid on; hold on; 
h = meshc( adBm_Avg, fDSB_LSNA_dB, bf1f2_DSB_LSNA );	grid on; hold on; 
title('Measured Pin, f1 and f2', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight);
%++++++++++++++++++++ IM3
h = meshc( adBm_Avg, fDSB_LSNA_dB, bim3_DSB_LSNA);	grid on; hold on; 
title('Measured IM3', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight);
%meshc( adBm_Avg, Lin2dB(LSNA_IM3.df_BB/1000)/2, squeeze(Vrms2dBm(LSNA_IM3.b2_im3l(:,1,1,:))) );      xlabel('Pin (dBm)'); ylabel('Tone Spacing (dBKhz)'); zlabel('Pout (dBm)'); grid on; hold on; 
%++++++++++++++++++++
set(h, 'LineWidth',PlotOpt.Ln_Width)
set(gca, 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
xlabel('Pin (dBm)', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
ylabel('Tone Spacing (dBKhz)', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
zlabel('Pout (dBm)', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 

figure(fig_Mesh);
%++++++++++++++++++++ H3
h = meshc( adBm_Avg, fDSB_LSNA_dB, real(Lin2dB_dB(H3_LSNAavg)));	set(h, 'FaceAlpha',0.5); grid on; hold on; 
zlabel('dB ()', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
h = mesh( adBm_Avg, fDSB_LSNA_dB, imag(Lin2dB_dB(H3_LSNAavg)));		set(h, 'FaceAlpha',0.5); grid on; hold on; 
zlabel('Pha (deg)', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight);
%++++++++++++++++++++ H3
h = meshc( adBm_Avg, fDSB_LSNA_dB, real(H3_LSNAavg));               set(h, 'FaceAlpha',0.5); grid on; hold on; 
zlabel('Real ()', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
h = meshc( adBm_Avg, fDSB_LSNA_dB, imag(H3_LSNAavg));               set(h, 'FaceAlpha',0.5); grid on; hold on; 
zlabel('Imag ()', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
%++++++++++++++++++++ 
set(h, 'LineWidth',PlotOpt.Ln_Width)
set(gca, 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
xlabel('Pin (dBm)', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
ylabel('Tone Spacing (dBKhz)', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight); 
title('Measured H3 from IM3', 'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight);

end