function [a_mat b_mat] = PolyFit_AMPM2( x_dBm, h, ordVEC, figVEC, ...
	Opt_AmpmType, Opt_OddEven, Opt_norm, ...
	mark, PlotOpt)
%   x_dBm:    	dBm     	[pwrs,1]=[COLvec]
%   AMPM_dBm: 	h = dBm_dB  [pwrs,1]=[COLvec]
%   S:          h = 'dB'    ''
%   y:          h = 'RI'    ''
x_dBm   = reshape(x_dBm,    [length(x_dBm) 1]);
x_Vp0	= dBm2Vp0(x_dBm);
h       = reshape(h,        [length(x_dBm) 1]);

%% ############################################################
switch Opt_AmpmType
	case {'AMPM_dBm'}
        zo      = 1;
        y_dBm   = h;
        y_Vp0	= dBm2Vp0_RI(y_dBm);
        h       = y_dBm - x_dBm;
    case {'S21','S12'}
        zo      = 1;
        y_dBm  	= x_dBm + h;% x_dBm = dBm + j*0deg
        y_Vp0	= dBm2Vp0_RI(y_dBm);
    case {'Y11','Y22', 'Y21','Y12'}
        zo      = 25;
        y_Vp0 	= x_Vp0 .* (h*zo);% really (Vin_rms * Y21 = Iout) * zo
        y_dBm 	= x_dBm + Lin2dB_dB((h*zo), 'UnWrap');
end

LineSpec_DATA = '-co';
if (figVEC(1) > 0)% fig_AMPM
    plot_Sio_Func2(x_dBm, y_dBm, figure(figVEC(1)),...
        'dB',{'yLin'},{'xLin'},{}, ...
        {'dBm MA'},{'dBm'},{'dBm' 'Deg'},{'Data'}, ...
        LineSpec_DATA, PlotOpt)
end
%if (figVEC(2) > 0)% fig_IQdBm
%    plot_Sio_Func2(x_dBm, Vp02dBm(real(y_Vp0)) + j*Vp02dBm(imag(y_Vp0)), figure(figVEC(2)),...
%        'RI',{'yLin'},{'xLin'},{}, ...
%        {'dBm IQ'},{'dBm'},{'dBm'},{'Data'}, ...
%        LineSpec_DATA, PlotOpt)
%end
if (figVEC(3) > 0)% fig_IQrms
%    plot_Sio_Func2(x_Vp0, y_Vp0, figure(figVEC(3)),...
%        'RI',{'yLin'},{'xLog'},{}, ...
%        {'Vp0 IQ'},{'Vp0'},{'Vp0'},{'Data'}, ...
%        LineSpec_DATA, PlotOpt)
    plot_Sio_Func2(x_dBm, y_Vp0, figure(figVEC(3)),...
        'RI',{'yLin'},{'xLin'},{}, ...
        {'Vp0 IQ'},{'dBm'},{'Vp0'},{'Data'}, ...
        LineSpec_DATA, PlotOpt)
end

%% ############################################################
b_mat	= zeros(length(ordVEC), ordVEC(end)+1);
a_mat	= zeros(length(ordVEC), ordVEC(end)+1);
for k = 1 : length(ordVEC)
    n = ordVEC(k)
    [b y_EST delta]     = PolyFit_Func(x_Vp0, y_Vp0, n, struct('OddEven',Opt_OddEven, 'norm',Opt_norm));
    b_mat(k, 1:(n+1))	= b;% [const [n]]
    size(y_EST)
    y_ESTmat(:,k)       = y_EST;% [pwrs,ord] alter to fit dimension-of-y

    switch Opt_OddEven
        %####################
        case {'Odd'}
            for l = 1 : 2 : n% (2*(ceil(n/2)-1)+1)% odd# in (0,n)
                %##### index after fliplr(b): j=l+1 in (1,n+1)
                a_mat(k,l+1)	= b_mat(k,l+1) / (nchoosek(l,ceil(l/2)) / 2^(l-1));
                %[nchoosek(l,ceil(l/2))  2^(l-1) 2^(ceil(l/2)-1)] % for debug
                %INCORR using Vrms: a_mat(k,l+1)	= b_mat(k,l+1) / (nchoosek(l,ceil(l/2)) / 2^(ceil(l/2)-1));
                %##### index before fliplr(b): (n+1)-j+1 = (n+1)-(l+1)+1
                %a_mat(k,l)	= b(1,(n+1)-(l+1)+1) * (2^(l-1) / nchoosek(l,ceil(l/2))); 
            end
            n_Ord       = (1:2:n);% need odd n to keep even# coeff
            Idx_PS      = n_Ord + 1;
            Idx_Misc    = n_Ord;
        %####################
        case {'Even'}
            for l = 0 : 2 : n% even# in (0,n)
                [l ceil(l/2) nchoosek(l,ceil(l/2)) 2^(l-1)]
                %a_mat(k,l+1) = b_mat(k,l+1) / (nchoosek(l,ceil(l/2))/2^(l-1)); % added / 2^(ceil(l/2)-1)
            end
            n_Ord       = (0:2:n);% need odd n to keep even# coeff
            Idx_PS      = n_Ord;
            Idx_Misc    = n_Ord + 1;
    end
%%############################################################
end
    a_mat = 1/zo * a_mat;

%%
y_ESTmat_dBm = Vp02dBm_dB(y_ESTmat);
a_matdB     = Lin2dB_dB(a_mat);
b_matdB     = Lin2dB_dB(b_mat);

for k = 1 : length(ordVEC)
    n = ordVEC(k);
    y_EST   = (y_ESTmat(:,k));
    LineSpec_MDL = ['-' PlotOpt.colors(ColorIndex_Func(k,PlotOpt.colors)) mark];
%------------------------------------------------
if (figVEC(1) > 0)
    plot_Sio_Func2(x_dBm, y_ESTmat_dBm(:,k), figure(figVEC(1)),...
        'dB',{'yLin'},{'xLin'},{}, ...
        {'dBm MA'},{'dBm'},{'dBm' 'Deg'},{'' ['MaxOrd ' num2str(n)]}, ...
        LineSpec_MDL, PlotOpt)
end
%if (figVEC(2) > 0)
%    plot_Sio_Func2(x_dBm, Vp02dBm(real(y_ESTmat(:,k))) + j*Vp02dBm(imag(y_ESTmat(:,k))), figure(figVEC(2)),...
%        'RI',{'yLin'},{'xLin'},{}, ...
%        {'dBm IQ'},{'dBm'},{'dBm'},{'' ['MaxOrd ' num2str(n)]}, ...
%        LineSpec_MDL, PlotOpt)
%end
if (figVEC(3) > 0)
%    plot_Sio_Func2(x_Vp0, y_EST, figure(figVEC(3)),...
%        'RI',{'yLin'},{'xLog'},{}, ...
%        {'Vp0 IQ'},{'Vp0'},{'Vp0'},{'' ['MaxOrd ' num2str(n)]}, ...
%        LineSpec_MDL, PlotOpt)
    plot_Sio_Func2(x_dBm, y_EST, figure(figVEC(3)),...
        'RI',{'yLin'},{'xLin'},{}, ...
        {'Vp0 IQ'},{'dBm'},{'Vp0'},{'' ['MaxOrd ' num2str(n)]}, ...
        LineSpec_MDL, PlotOpt)
end
if (figVEC(4) > 0)
        %y_ESTerr_dBc = Lin2dB((y_Vp0-y_EST)./y_Vp0 ) + j*(imag(Lin2MA_MA(y_Vp0)) - imag(Lin2MA_MA(y_EST)));
        %Mag_RelErr_dBc + j*Pha_Err
        y_ESTerr_dBc = Lin2dB((y_Vp0-y_EST)./y_Vp0) + j*(imag(y_dBm)-imag(y_ESTmat_dBm(:,k)));
        %y_dBm - y_ESTmat_dBm;
    plot_Sio_Func2(x_dBm, y_ESTerr_dBc, figure(figVEC(4)),...
        'dB',{'yLin'},{'xLin'},{}, ...
        {'Vp0 MA-ESTerr'},{'dBm'},{'dBc' 'Deg'},{'' ['MaxOrd ' num2str(n)]}, ...
        LineSpec_MDL, PlotOpt)
end
if (figVEC(5) > 0)
        I_ESTerr_dBc	= Lin2dB( real(y_Vp0-y_ESTmat(:,k)) ./real(y_Vp0) ); 
        Q_ESTerr_dBc	= Lin2dB( imag(y_Vp0-y_ESTmat(:,k)) ./imag(y_Vp0) ); 
    plot_Sio_Func2(x_dBm, (I_ESTerr_dBc + j*Q_ESTerr_dBc), figure(figVEC(5)),...
        'RI',{'yLin'},{'xLin'},{}, ...
        {'Vp0 IQ-ESTerr'},{'dBm'},{'dBc'},{'' ['MaxOrd ' num2str(n)]}, ...
        LineSpec_MDL, PlotOpt)
	%semilogx(x_Vp0, deltaI,                    LineSpec_MDL ); hold on; grid on;
	%semilogx(x_Vp0, (real(y_Vp0) - I_rmsEST),  LineSpec_MDL ); hold on; grid on;
	%semilogx(x_Vp0, deltaQ,                 	LineSpec_MDL ); hold on; grid on;
	%semilogx(x_Vp0, (imag(y_Vp0) - Q_rmsEST),  LineSpec_MDL ); hold on; grid on;
end
%------------------------------------------------
    switch Opt_OddEven
        case {'Odd'}
            n_Ord       = (1:2:n);% need odd n to keep even# coeff
            Idx_PS      = n_Ord + 1;
            Idx_Misc    = n_Ord;
        case {'Even'}
            n_Ord       = (0:2:n);% need odd n to keep even# coeff
            Idx_PS      = n_Ord;
            Idx_Misc    = n_Ord + 1;
    end
if (figVEC(6) > 0)% need abs for complex a_mat, b
    plot_Sio_Func2(n_Ord, abs(a_mat(k,Idx_PS)) + j*abs(b(Idx_Misc)./b(Idx_PS)), figure(figVEC(6)),...
        'RI',{'yLogABS'},{'xLin'},{}, ...
        {'a(n)' 'b(n)'},{'CoefOrd'},{''},{'' ['MaxOrd ' num2str(n)]}, ...
        LineSpec_MDL, PlotOpt)
end
%------------------------------------------------
end

%%
if (figVEC(7) > 0)
        switch Opt_AmpmType
            case {'AMPM_dBm','S21','S12'}% dB
                h_Lin = h(1)
                a_Lin = a_matdB(:,Idx_PS(1))
                titleCEL_7  = {'h(1)'};
            case {'Y21','Y12'}% RI
                h_Lin = Lin2dB_dB( h(1)*zo )
                a_Lin = Lin2dB_dB( a_mat(:,Idx_PS(1))*zo )
                titleCEL_7  = {'h(1)*zo'};
            case {'Y11','Y22'}% RI
                h_Lin = Lin2MA_MA( 1./h(1) )
                a_Lin = Lin2MA_MA( 1./a_mat(:,Idx_PS(1)) )
                titleCEL_7  = {'1/h(1)'};
        end
        %pha_offset = zeros(size(ordVEC,1), 1);% length(a_mat(:,Idx_PS(1)))
        %pha_offset( find(abs(imag(h_Lin) - imag(a_Lin)) > 270) ) = 360% for debug
        %a_Lin = a_Lin + j*pha_offset;
    plot_Sio_Func2([ordVEC(1) ordVEC(end)], h_Lin*[1 1], figure(figVEC(7)),...
        'dB',{'yLin'},{'xLin'},{}, ...
        titleCEL_7,{'MaxOrd'},{},{'' 'h(1)'}, ...
        '-ko', PlotOpt)
    plot_Sio_Func2(ordVEC, a_Lin, figure(figVEC(7)),...
        'dB',{'yLin'},{'xLin'},{}, ...
        titleCEL_7,{'MaxOrd'},{},{'' 'a(1)'}, ...
        '-o', PlotOpt)
	%title('a_mat#');    xlabel('ordVEC n');        ylabel('a1 (dB)');         ylabel('a1 (degree)');
end

%% TEST
if(0)
    
	for l = 1 : 2 : 5
     	[nchoosek(l,ceil(l/2))  2^(l-1)]
      	%INCORR using Vrms: [nchoosek(l,ceil(l/2))  2^(ceil(l/2)-1)]
       	%a_mat(k,l+1)	= b_mat(k,l+1) / (nchoosek(l,ceil(l/2)) / 2^(ceil(l/2)-1));
	end
[	1     1;...
  	3     4;...
    10    16]
[ 	1     1;...
  	3     2;...
    10    4]
ceil(l/2) - 1% n
	%       0     1     2

n = (0:2)
l = 2*n + 1
    %       1     3     5
n + 1% ceil(l/2)
    %       1     2     3
2.^l
    %       2     8    32
2.^(l-1)
    %       1     4    16
    
end