function [b y_EST delta] = PolyFit_Func( x, y, ...
    n, Opt)
% x_DSB     Vp0
% y_DSB     Vp0
%    n = ordVEC(k)

switch Opt.OddEven
    case {'EvenOdd'}
        x_DSB	= x;
        y_DSB   = y;
    case {'Odd'}
        x_DSB	= [-flipud(x);  0; x];
        y_DSB   = [-flipud(y);  0; y];
    case {'Even'}
        x_DSB	= [-flipud(x);  x];
        y_DSB   = [flipud(y);   y];
end
%    plot_Sio_Func(x_DSB, y_DSB, ...
%        'RI','RI-Lin', figure(100),'Xlin',Mark_Meas, [],[],[])


%% ############################################################
switch Opt.norm
    %%############################################################
    case {1}
    [bI_norm, SI, muI]	= polyfit(x_DSB, real(y_DSB), n);
    [bQ_norm, SQ, muQ]	= polyfit(x_DSB, imag(y_DSB), n);
    [I_EST, deltaI]     = polyval(bI_norm, x, SI, muI);
    [Q_EST, deltaQ]     = polyval(bQ_norm, x, SQ, muQ);
    for l = 1 : n+1
        bI(l)	= bI_norm(1,l) / (std(x_DSB)^(n+1-l));
        bQ(l)	= bQ_norm(1,l) / (std(x_DSB)^(n+1-l));
    end
    %%############################################################
    case {0}% ill-condition for HIGH ORD 11,13
    [bI, SI]      	= polyfit(x_DSB, real(y_DSB), n);
    [bQ, SQ]       	= polyfit(x_DSB, imag(y_DSB), n);
    [I_EST, deltaI]	= polyval(bI, x, SI);
    [Q_EST, deltaQ]	= polyval(bQ, x, SQ);
    %%############################################################
    otherwise
        disp('Unknown Opt.norm');
end

    %b_norm     = fliplr( complex(bI_norm, bQ_norm) );
    b         	= fliplr( complex(bI, bQ) );
    y_EST       = complex(I_EST, Q_EST);
    delta       = complex(deltaI, deltaQ);