function [Phase] = Pha(S21, ContPha_ColRow, ...
    Opt_Unwrap, Opt_Pha)

if ~exist('ContPha_ColRow', 'var')
    ContPha_ColRow = 'ROW';
end
if ~exist('Opt_Unwrap', 'var')
    Opt_Unwrap = 'UnWrap';
end
if ~exist('Opt_Pha', 'var')
    Opt_Pha = 'deg';
end

%% ################################################## 
switch Opt_Unwrap
    %=====================================================
    case {'UnWrap'}
        %----------------------------------------------------
        if isvector(S21)% VECTOR
            Phase = unwrap(angle(S21));
        %----------------------------------------------------
        else% MATRIX(FREQ, PWR)
%unwrap(): each COL by default -> ContPha betw ROWs
switch ContPha_ColRow
	case('ROW')% ContPha betw COLs
            Phase_1 = (unwrap(angle(S21.'))).';
            % 1)cont unwrap(along PWR=ROW): ++++IMPORTANT++++
            % 2)offset by DIFF( unwrap(COL1), COL1 0f unwrap(PWR=ROW) )
            % Pha_Ref = low-PWR[==NOISY] 
            % slices betw FREQs @all-FREQ: all-PWR=cont 
            Phase_2 = unwrap(angle(S21(:,1)));% 1stCOL
            Offset  = Phase_2 - Phase_1(:,1);% match phase to 1stCOL
            Phase   = Phase_1 + repmat(Offset,[1 size(Phase_1,2)]);
	case('COL')% ContPha betw ROWs
            Phase_1 = unwrap(angle(S21));
            % 1)cont unwrap(along FREQ=COL): ++++NOT ALWAYS (not enough Freq resoln)++++ 
            % 2)offset by diff( unwrap(ROW1), ROW1 of unwrap(FREQ=COL) )
            % Pha_Ref = low-FREQ
            % slices betw PWRs @high-PWR: low-FREQ=cont, other-FREQ=DISCONT
            Phase_2 = unwrap(angle(S21(1,:)));% 1stROW
            Offset  = Phase_2 - Phase_1(1,:);% match phase to 1stROW
            Phase   = Phase_1 + repmat(Offset,[size(Phase_1,1) 1]);
end
        end
    %=====================================================
    otherwise% case {'No'}
        Phase = angle(S21);
	%=====================================================
end

%% ################################################## 
switch Opt_Pha
    case {'deg'}
        Phase = Phase /pi*180;
    otherwise% case {'rad'}
end