function [MIX fMIX MIXcoef Num_MixVec] = Mix_2tone(...
            Q, fVEC,fVECsym, n, ...
            Sort_Flag, Disp_Flag, HD_Flag)
% Actual Symbolic Freq:         fVEC    =[2*f2 f1] 
% Symbols in Symbolic Freq:     fVECsym =[f2   f1]
% "fMIX" constructed from "fVEC"    sub(fMIX, fVECsym, fVECnum)

switch HD_Flag
    case {'No_HD'}
        n_UpLim = n-1;
    otherwise % {'wHD'}
     	n_UpLim = n;
end

%%
MIXcount	= [];
fMIX     	= [];
MIX     	= [];
switch Q
    %#########################################################
    case 1 %Q=1 for 1-tone, thus MIX = [m1 m2]
fVECnum = {-200,200};
for m1 = 0 : n_UpLim
for m2 = 0 : n_UpLim
    MIXvec  = [m1 m2];      %Freq-Mix Vector
    if (sum(MIXvec,2) == n)
        fm_temp = MIXvec * fVEC.';
        %if (fm_temp==0) || (isempty(find(fMIX == fm_temp)))
        fMIX  = [fMIX fm_temp]; %Freq-Mix
        MIX   = [MIX; MIXvec];  %Freq-Mix Matrix
        MIXcount = [MIXcount Multinomial(MIXvec, n)]; %Freq-Mix Coeff
        %end
    end
end
end
    %#########################################################
    case 2 %Q=2 for 2-tone, thus MIX = [m1 m2 m3 m4]
fVECnum = {-201,-200,200,201};
for m1 = 0 : n_UpLim
for m2 = 0 : n_UpLim
for m3 = 0 : n_UpLim
for m4 = 0 : n_UpLim
    MIXvec  = [m1 m2 m3 m4];
    if (sum(MIXvec,2) == n)
        fm_temp = MIXvec * fVEC.';
        %if (fm_temp==0) || (isempty(find(fMIX == fm_temp)))
        fMIX  = [fMIX fm_temp];
        MIX   = [MIX; MIXvec];
        MIXcount = [MIXcount Multinomial(MIXvec, n)];
        %end
    end
end
end
end
end
    %#########################################################
    case 3 %Q = 3 for 3-tone, thus MIX = [m1 m2 m3 m4 m5 m6]
fVECnum = {-202,-201,-200,200,201,202};
for m1 = 0 : n_UpLim
for m2 = 0 : n_UpLim
for m3 = 0 : n_UpLim
for m4 = 0 : n_UpLim
for m5 = 0 : n_UpLim
for m6 = 0 : n_UpLim
    MIXvec  = [m1 m2 m3 m4 m5 m6];
    if (sum(MIXvec,2) == n)
        fm_temp = MIXvec * fVEC.';
        %if (fm_temp==0) || (isempty(find(fMIX == fm_temp)))
        fMIX  = [fMIX fm_temp];
        MIX   = [MIX; MIXvec];
        MIXcount = [MIXcount Multinomial(MIXvec, n)];
        %end
    end
end
end
end
end
end
end
    %#########################################################
    otherwise
        disp('Q > 3'); return;
end
MIXcoef     = MIXcount / 2^n;  %Freq-Mix Coeff

%%
switch Sort_Flag
    %###################
    case {'fMIXcoef'}
        % Re-Arrange
        MIX       	= flipud(MIX);
        fMIX     	= fliplr(fMIX);
        MIXcount	= fliplr(MIXcount);
        MIXcoef 	= fliplr(MIXcoef);
        [MIXcoef idx] = sort(MIXcoef, 'descend');
        fMIX        = fMIX(idx);
    %###################
    case {'fMIX'}
        if isa(fVEC, 'numeric')
            [fMIX idx]	= sort(fMIX, 'descend');
        else
            [fm_num idx] = sort(single(subs(fMIX,fVECsym,fVECnum)), 'descend');
            fMIX  	= fMIX(idx);
        end
        MIXcoef     = MIXcoef(idx);
	%###################
    otherwise
        disp('Unknow Sort_Flag');
end
    MIX         = MIX(idx,:);
    MIXcount    = MIXcount(idx);

if (Disp_Flag == 1)
    [MIX fMIX.' MIXcount.' sym(MIXcoef.')]
end
if (nargout > 4)
    Num_MixVec  = factorial(2*Q+n-1) / factorial(n) / factorial(2*Q-1)
    Num_mVec    = size(MIX,1)
end

%% TEST, Notes
if (0)
    Q = 1;  % for 1-tone, thus MIX = [m1 m2]
        fVEC = [-f1 f1];
    Q = 2;  % for 2-tone, thus MIX = [m1 m2 m3 m4]
        fVEC = [-f2 -f1 f1 f2];
    n = 1
    [MIX fMIX MIXcoef] = Mix_2tone(Q, fVEC, n);
Q=1
n=1
%[   1,   0, -f1,   1, 1/2]
%[   0,   1,  f1,   1, 1/2]
n=2
%[     1,     1,     0,     2,   1/2]
%[     2,     0, -2*f1,     1,   1/4]
%[     0,     2,  2*f1,     1,   1/4]
n=3
%[     2,     1,   -f1,     3,   3/8]
%[     1,     2,    f1,     3,   3/8]
%[     3,     0, -3*f1,     1,   1/8]
%[     0,     3,  3*f1,     1,   1/8]
n=4
%[     0,     4,  4*f1,     1,  1/16]
%[     1,     3,  2*f1,     4,   1/4]
%[     2,     2,     0,     6,   3/8]
%[     3,     1, -2*f1,     4,   1/4]
%[     4,     0, -4*f1,     1,  1/16]
n=5
%[     0,     5,  5*f1,     1,  1/32]
%[     1,     4,  3*f1,     5,  5/32]
%[     2,     3,    f1,    10,  5/16]
%[     3,     2,   -f1,    10,  5/16]
%[     4,     1, -3*f1,     5,  5/32]
%[     5,     0, -5*f1,     1,  1/32]

Q=2
n=1
%[   1,   0,   0,   0, -f2,   1, 1/2]
%[   0,   1,   0,   0, -f1,   1, 1/2]
%[   0,   0,   1,   0,  f1,   1, 1/2]
%[   0,   0,   0,   1,  f2,   1, 1/2]
n=2
%[      1,      1,      0,      0, -f2-f1,      2,    1/2]
%[      1,      0,      1,      0, -f2+f1,      2,    1/2]
%[      1,      0,      0,      1,      0,      2,    1/2]
%[      0,      1,      1,      0,      0,      2,    1/2]
%[      0,      1,      0,      1, -f1+f2,      2,    1/2]
%[      0,      0,      1,      1,  f1+f2,      2,    1/2]
%[      2,      0,      0,      0,  -2*f2,      1,    1/4]
%[      0,      2,      0,      0,  -2*f1,      1,    1/4]
%[      0,      0,      2,      0,   2*f1,      1,    1/4]
%[      0,      0,      0,      2,   2*f2,      1,    1/4]
n=3
%[        1,        1,        1,        0,      -f2,        6,      3/4]
%[        1,        1,        0,        1,      -f1,        6,      3/4]
%[        1,        0,        1,        1,       f1,        6,      3/4]
%[        0,        1,        1,        1,       f2,        6,      3/4]
%[        2,        1,        0,        0, -2*f2-f1,        3,      3/8]
%[        2,        0,        1,        0, -2*f2+f1,        3,      3/8]
%[        2,        0,        0,        1,      -f2,        3,      3/8]
%[        1,        2,        0,        0, -f2-2*f1,        3,      3/8]
%[        1,        0,        2,        0, -f2+2*f1,        3,      3/8]
%[        1,        0,        0,        2,       f2,        3,      3/8]
%[        0,        2,        1,        0,      -f1,        3,      3/8]
%[        0,        2,        0,        1, -2*f1+f2,        3,      3/8]
%[        0,        1,        2,        0,       f1,        3,      3/8]
%[        0,        1,        0,        2, -f1+2*f2,        3,      3/8]
%[        0,        0,        2,        1,  2*f1+f2,        3,      3/8]
%[        0,        0,        1,        2,  f1+2*f2,        3,      3/8]
%[        3,        0,        0,        0,    -3*f2,        1,      1/8]
%[        0,        3,        0,        0,    -3*f1,        1,      1/8]
%[        0,        0,        3,        0,     3*f1,        1,      1/8]
%[        0,        0,        0,        3,     3*f2,        1,      1/8]
n=3
%[        0,        0,        0,        3,     3*f2,        1,      1/8]
%[        0,        0,        1,        2,  f1+2*f2,        3,      3/8]
%[        0,        0,        2,        1,  2*f1+f2,        3,      3/8]
%[        0,        0,        3,        0,     3*f1,        1,      1/8]
%[        0,        1,        0,        2, -f1+2*f2,        3,      3/8]
%[        1,        0,        0,        2,       f2,        3,      3/8]
%[        0,        1,        1,        1,       f2,        6,      3/4]
%[        1,        0,        1,        1,       f1,        6,      3/4]
%[        0,        1,        2,        0,       f1,        3,      3/8]
%[        1,        0,        2,        0, -f2+2*f1,        3,      3/8]
%[        0,        2,        0,        1, -2*f1+f2,        3,      3/8]
%[        1,        1,        0,        1,      -f1,        6,      3/4]
%[        0,        2,        1,        0,      -f1,        3,      3/8]
%[        2,        0,        0,        1,      -f2,        3,      3/8]
%[        1,        1,        1,        0,      -f2,        6,      3/4]
%[        2,        0,        1,        0, -2*f2+f1,        3,      3/8]
%[        0,        3,        0,        0,    -3*f1,        1,      1/8]
%[        1,        2,        0,        0, -f2-2*f1,        3,      3/8]
%[        2,        1,        0,        0, -2*f2-f1,        3,      3/8]
%[        3,        0,        0,        0,    -3*f2,        1,      1/8]
n = 5
%[          0,          0,          0,          5,       5*f2,          1,       1/32]
%[          0,          0,          1,          4,    f1+4*f2,          5,       5/32]
%[          0,          0,          2,          3,  2*f1+3*f2,         10,       5/16]
%[          0,          0,          3,          2,  3*f1+2*f2,         10,       5/16]
%[          0,          0,          4,          1,    4*f1+f2,          5,       5/32]
%[          0,          0,          5,          0,       5*f1,          1,       1/32]
%[          0,          1,          0,          4,   -f1+4*f2,          5,       5/32]
%[          0,          1,          1,          3,       3*f2,         20,        5/8]
%[          1,          0,          0,          4,       3*f2,          5,       5/32]
%[          0,          1,          2,          2,    f1+2*f2,         30,      15/16]
%[          1,          0,          1,          3,    f1+2*f2,         20,        5/8]
%[          0,          1,          3,          1,    2*f1+f2,         20,        5/8]
%[          1,          0,          2,          2,    2*f1+f2,         30,      15/16]
%[          0,          1,          4,          0,       3*f1,          5,       5/32]
%[          1,          0,          3,          1,       3*f1,         20,        5/8]
%[          1,          0,          4,          0,   -f2+4*f1,          5,       5/32]
%[          0,          2,          0,          3, -2*f1+3*f2,         10,       5/16]
%[          0,          2,          1,          2,   -f1+2*f2,         30,      15/16]
%[          1,          1,          0,          3,   -f1+2*f2,         20,        5/8]
%[          0,          2,          2,          1,         f2,         30,      15/16]
%[          1,          1,          1,          2,         f2,         60,       15/8]
%[          2,          0,          0,          3,         f2,         10,       5/16]
%[          0,          2,          3,          0,         f1,         10,       5/16]
%[          1,          1,          2,          1,         f1,         60,       15/8]
%[          2,          0,          1,          2,         f1,         30,      15/16]
%[          1,          1,          3,          0,   -f2+2*f1,         20,        5/8]
%[          2,          0,          2,          1,   -f2+2*f1,         30,      15/16]
%[          2,          0,          3,          0, -2*f2+3*f1,         10,       5/16]
%[          0,          3,          0,          2, -3*f1+2*f2,         10,       5/16]
%[          0,          3,          1,          1,   -2*f1+f2,         20,        5/8]
%[          1,          2,          0,          2,   -2*f1+f2,         30,      15/16]
%[          0,          3,          2,          0,        -f1,         10,       5/16]
%[          1,          2,          1,          1,        -f1,         60,       15/8]
%[          2,          1,          0,          2,        -f1,         30,      15/16]
%[          1,          2,          2,          0,        -f2,         30,      15/16]
%[          2,          1,          1,          1,        -f2,         60,       15/8]
%[          3,          0,          0,          2,        -f2,         10,       5/16]
%[          2,          1,          2,          0,   -2*f2+f1,         30,      15/16]
%[          3,          0,          1,          1,   -2*f2+f1,         20,        5/8]
%[          3,          0,          2,          0, -3*f2+2*f1,         10,       5/16]
%[          0,          4,          0,          1,   -4*f1+f2,          5,       5/32]
%[          0,          4,          1,          0,      -3*f1,          5,       5/32]
%[          1,          3,          0,          1,      -3*f1,         20,        5/8]
%[          1,          3,          1,          0,   -f2-2*f1,         20,        5/8]
%[          2,          2,          0,          1,   -f2-2*f1,         30,      15/16]
%[          2,          2,          1,          0,   -2*f2-f1,         30,      15/16]
%[          3,          1,          0,          1,   -2*f2-f1,         20,        5/8]
%[          3,          1,          1,          0,      -3*f2,         20,        5/8]
%[          4,          0,          0,          1,      -3*f2,          5,       5/32]
%[          4,          0,          1,          0,   -4*f2+f1,          5,       5/32]
%[          0,          5,          0,          0,      -5*f1,          1,       1/32]
%[          1,          4,          0,          0,   -f2-4*f1,          5,       5/32]
%[          2,          3,          0,          0, -2*f2-3*f1,         10,       5/16]
%[          3,          2,          0,          0, -3*f2-2*f1,         10,       5/16]
%[          4,          1,          0,          0,   -4*f2-f1,          5,       5/32]
%[          5,          0,          0,          0,      -5*f2,          1,       1/32]

    Q = 1;  % for 1-tone, thus MIX = [m1 m2]
        fVEC = [-10 10];
    %###################
    Q = 2;  % for 2-tone, thus MIX = [m1 m2 m3 m4]
        fVEC = [-11 -10 10 11];
    n = 3;
    [MIX fMIX MIXcoef] = Mix_2tone(Q, fVEC, n);
Q=1 
n=2
%[   1,   1,   0,   2, 1/2]
%[   2,   0, -20,   1, 1/4]
%[   0,   2,  20,   1, 1/4]
n=3
%[   2,   1, -10,   3, 3/8]
%[   1,   2,  10,   3, 3/8]
%[   3,   0, -30,   1, 1/8]
%[   0,   3,  30,   1, 1/8]

Q=2
n=2 %Num_MixVec = 10
%[   1,   1,   0,   0, -21,   2, 1/2]
%[   1,   0,   1,   0,  -1,   2, 1/2]
%[   0,   1,   1,   0,   0,   2, 1/2]
%[   1,   0,   0,   1,   0,   2, 1/2]
%[   0,   1,   0,   1,   1,   2, 1/2]
%[   0,   0,   1,   1,  21,   2, 1/2]
%[   2,   0,   0,   0, -22,   1, 1/4]
%[   0,   2,   0,   0, -20,   1, 1/4]
%[   0,   0,   2,   0,  20,   1, 1/4]
%[   0,   0,   0,   2,  22,   1, 1/4]
n=3 %Num_MixVec = 20
%[   1,   1,   1,   0, -11,   6, 3/4]
%[   1,   1,   0,   1, -10,   6, 3/4]
%[   1,   0,   1,   1,  10,   6, 3/4]
%[   0,   1,   1,   1,  11,   6, 3/4]
%[   2,   1,   0,   0, -32,   3, 3/8]
%[   1,   2,   0,   0, -31,   3, 3/8]
%[   2,   0,   1,   0, -12,   3, 3/8]
%[   2,   0,   0,   1, -11,   3, 3/8]
%[   0,   2,   1,   0, -10,   3, 3/8]
%[   0,   2,   0,   1,  -9,   3, 3/8]
%[   1,   0,   2,   0,   9,   3, 3/8]
%[   0,   1,   2,   0,  10,   3, 3/8]
%[   1,   0,   0,   2,  11,   3, 3/8]
%[   0,   1,   0,   2,  12,   3, 3/8]
%[   0,   0,   2,   1,  31,   3, 3/8]
%[   0,   0,   1,   2,  32,   3, 3/8]
%[   3,   0,   0,   0, -33,   1, 1/8]
%[   0,   3,   0,   0, -30,   1, 1/8]
%[   0,   0,   3,   0,  30,   1, 1/8]
%[   0,   0,   0,   3,  33,   1, 1/8]
%#################################################
% check
n_chos_m = [];
for n_1 = 1 : size(fm_m,1)
    n_chos_m(n_1) = Multinomial(fm_m(n_1,:), n);
end
n_chos_m
%#################################################
% poly-mult = conv, fast way to find MIXcount
f_poly = ones(1,length(fVEC))
n = 3
MIXcount = f_poly;
for n1 = 1 : n-1
    MIXcount = conv(MIXcount, f_poly);
end
MIXcount
%#################################################
% don't work b.c PolyMult, not ADD
fMIX  = [];
MIXcount = [];
fm_m = [];
for m1 = 0 : n
    m2 = n - m1;
    %for m2 = 0 : n
    %if (m1 + m2 == n)
    fm_temp = [m1 m2] * fVEC.'
    idx = find(fMIX == fm_temp);
	if isempty(idx)
        fMIX = [fMIX fm_temp];
        MIXcount = [MIXcount 1];
        fm_m = [fm_m; [m1 m2]];
    else
        MIXcount(idx) = MIXcount(idx) + 1;
    end
end
fMIX
MIXcount
fm_m
%#################################################
end