function [Freq_Hz	Snp     Header] = Read_SnP_Func( FileNam, ...
        NumPort, Opt )
% FileNam           = File_P4coupler;
% NumPort           = 3;
% Opt.IOformat      = 'dB2dB';
% Opt.IOPortConv    = 'Gen_2_Gen';

if ~isfield( Opt,'IOPortConv' )
    disp('Missing Opt.IOPortConv')
    return
end

%% ############################### Read Input 
FormatStr = repmat('%f ',1,1+2*NumPort^2);
fid	= fopen(FileNam, 'r')
    Header	= textscan(fid,'%s %s %s %s %s %s',1, ...
        'whitespace',' \b\t\n\r', 'commentStyle','!');% celldisp( Header )
        HeaderSTR = [];
        for n = 1 : length( Header )
            HeaderSTR = [HeaderSTR   ' ' [Header{n}{:}]];
        end
        HeaderSTR
    c 	= textscan(fid,FormatStr, ...
        'whitespace',' \b\t\n\r', 'commentStyle','!');% textread: better param dscrp than textscan
    %c 	= textscan(fid,FormatStr, ...
    %    'whitespace',' \b\t', 'delimiter','\n', 'commentStyle','!');% celldisp(c)
    %c	= textscan(fid,'%f %f%f %f%f %f%f %f%f',NumPts, ...
    %    'headerLines',Num_HeadLines);
fclose(fid);

%--------------------------------------------------------- Format Freq
	switch upper( Header{1}{1} )
      	case{'HZ'}
         	Freq_Scale = 1
      	case{'KHZ'}
          	Freq_Scale = 1e3
      	case{'MHZ'}
          	Freq_Scale = 1e6
      	case{'GHZ'}
         	Freq_Scale = 1e9
        otherwise
         	Freq_Scale = 1
    end
Freq_Hz = c{1} * Freq_Scale;
    [length( Freq_Hz )      NumPort^2]
%--------------------------------------------------------- Format Output
for n_idx = 2 : 2 : length(c)
    n_port = n_idx / 2;
    switch Opt.IOformat
        case{'RI2RI'} % output RI, input RI
            Snp{n_port} = c{n_idx} + j*c{n_idx+1};
        case{'RI2dB'} % output dB, input RI
            %Snp{n_port} = Lin2dB( c{n_idx}+j*c{n_idx+1} ) + j*(unwrap(angle( c{n_idx}+j*c{n_idx+1} ))/pi*180);
            Snp{n_port} = Lin2dB_dB( c{n_idx}+j*c{n_idx+1},'UnWrap' );
        case{'dB2dB'} % output dB, input dB
            Snp{n_port} = c{n_idx} + j*(unwrap( c{n_idx+1}/180*pi )/pi*180);
        case{'dB2RI'} % output RI, input dB
            Snp{n_port} = dB2Lin_RI( c{n_idx}+j*c{n_idx+1} );
    end
end
%---------------------------------------------------------
%########## Arrange Output for Freeda, which use General-Convention always
%n>2port:   General-Convention	ADS-PNA[1x 2x 3x]    -> No Change Needed    =>PREFERRED
%2port:     Special-Convention	ADS-PNA[11 21 12 22] -> [1x 2x]
if(NumPort==2)
    switch Opt.IOPortConv
        case{'Gen_2_Gen'            'ADSPNA2port_2_ADSPNA2port'}
            disp('Keep IOPortConvention for 2port')
        case{'Gen_2_ADSPNA2port'	'ADSPNA2port_2_Gen'}
            temp    = Snp{2};
            Snp{2}  = Snp{3};
            Snp{3}  = temp;
    end
end

%% ################################################## Test
if(0)

Path_PNA_Data = 'M:\users\jhu\freeda_v13\components';
%
FileNam = 'ADSpwrsplit_1hz_1thz_RI_y2p.s3p';
NumPort = 3;
%
FileNam = 'ADSpwrsplit_1hz_1thz_RI_y2p_12.s2p';
NumPort = 2;
%
Opt.IOformat = 'RI_RI';
[Freq_Hz Snp] = Read_SnP_Func(Path_PNA_Data, FileNam, NumPort, Opt.IOformat);

end