function [ ] = Write_SnP_Freeda( Freq, Snp, NumPort, ...
    FileNam, Opt)
if isempty( Opt.Precision )
    Opt.Precision = '%16.15e ';
else
	Opt.Precision = [Opt.Precision ' '];
end

NumPts  = length(Freq);

%% ########## Write Header
fid = fopen( FileNam, 'w')
	fprintf(fid, '# port:group \n');
for nPORT = 1 : NumPort
	fprintf(fid, '%d:%d \n', nPORT, nPORT);
end
    %fprintf(fid,'\n%s ', Opt.Header);
    fprintf(fid,'\n%s %s %s %s %s %d ','#',Opt.Header{2}{1},'Y','RI','R',Opt.Zo);

%% ########## Write Data
for nF = 1 : NumPts
        fprintf(fid,['\n' Opt.Precision '\n'], Freq(nF));
    for nTERM = 1 : length( Snp )
        fprintf(fid,[Opt.Precision Opt.Precision '\n'], real(Snp{nTERM}(nF)), imag(Snp{nTERM}(nF)));
    end
end

fclose(fid);
%% ########## Test
if(0)
    
%++++++++++++++ Write Freeda
File_Save = fullfile(PATH.ADS_models, lower([DUT '_VSAys21_y2p' '.s2p']))
Write_SnP_Freeda(f_s21.', y_s21_Mat, ...
    File_Save, {'%10.9g'}, {'HZ' 'Y' 'RI' '50'});



%FileNam_1   = 'components\ADSsawtek_465Mhz_2Ghz_RI_y2p.s2p';
Path_PNA_Data = 'M:\users\jhu\freeda_v13\components';
FileNam = 'adspwrsplit_1hz_1thz_ri_y2p_freeda.s3p';
Opt_Header = {'MHz' 'Y' 'RI' 50};
[NumPts] = Write_SnP_Freeda( Freq, Snp, Path_PNA_Data, FileNam, Opt_Header)

end